hmLoadTopic({
hmKeywords:"",
hmTitle:"Adding RTSP, HTTP, or Multicast Streams as Cameras",
hmDescription:"Occasionally a camera cannot be automatically discovered, or will not work properly in DW Spectrum because it is not fully compatible with ONVIF. These devices can instead be...",
hmPrevLink:"adding_cameras_manually.html",
hmNextLink:"addng_a_webcam_or_raspberry_pi.html",
hmParentLink:"adding_cameras.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_cameras.html\">Device Management<\/a> &gt; <a href=\"adding_cameras.html\">Adding Devices<\/a>",
hmTitlePath:"Working with DW Spectrum > Device Management > Adding Devices > Adding RTSP, HTTP, or Multicast Streams as Cameras",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Adding RTSP, HTTP, or Multicast Streams as Cameras<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">Occasionally a camera&nbsp;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">cannot be automatically discovered, or will not&nbsp;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">work properly in DW Spectrum because it is not fully compatible with&nbsp;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">ONVIF. These devices&nbsp;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">can instead be added using their&nbsp;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">RTSP,<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">HTTP<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">, or UDP m<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">ulticast URL stream address. Once added, such a camera<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;can be successfully viewed and recorded in DW Spectrum, including audio output over RTSP for devices that record audio.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">It is possible to add two streams when creating an RTSP\/HTTP camera, which enables dual streaming and adaptive scaling (see &quot;<a href=\"dual_streaming.html\" class=\"topiclink\">Dual Stream Processing<\/a>&quot;). Dual-stream cameras from RTSP, HTTP, or UDP streams allow for the integration of third party legacy IP Cameras, DVRs, and NVRs with full DW Spectrum adaptive scaling capabilities for reduced CPU and network usage.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\" style=\"background-color: #ffffff;\">&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold; background-color: #ffffff;\">IMPORTANT<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">:<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;You must<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">&nbsp;know the exact<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">&nbsp;RTSP\/HTTP\/UDP URL<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">&nbsp;of the stream. This information can be found in the camera manual, on the camera web page, or by contacting the manufacturer.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">Follow the steps described in &quot;<a href=\"adding_cameras_manually.html\" class=\"topiclink\">Adding Devices Manually<\/a>&quot; for a single device to add the desired stream<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"background-color: #ffffff;\">&nbsp;value&nbsp;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">in the&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold; background-color: #ffffff;\">Address<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;field. Once added, the camera will be displayed in the Resource Panel as a &quot;GENERIC_<\/span><span class=\"f_BodyText\" style=\"font-style: italic; background-color: #ffffff;\">stream type_stream name&quot;.<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;You can then use&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold; background-color: #ffffff;\">Edit Streams<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;in&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold; background-color: #ffffff;\">Camera Settings<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;&gt;&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold; background-color: #ffffff;\">General<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;to add or edit either stream value. Not all RTSP devices are compatible with the quality and FPS selection capability in the Client.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"Adding RTSP Stream as - 1\" style=\"margin:0;width:49.7500rem;height:32.1875rem;border:none\" src=\".\/images\/hmfile_hash_a721bd77.jpg\"\/><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\" style=\"background-color: #ffffff;\">&nbsp;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold; background-color: #ffffff;\">Note:<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">&nbsp;If the lowest resolution is greater than 1024x768p, software motion detection will not be available.<\/span><\/p>\n\r"
})
