hmLoadTopic({
hmKeywords:"",
hmTitle:"LDAP Users and Groups",
hmDescription:"LDAP integration allows a System to import Users and User Groups from an LDAP Server.",
hmPrevLink:"roles_management.html",
hmNextLink:"viewing_users_actions_log_audi.html",
hmParentLink:"users-and-groups.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"users-and-groups.html\">Users and Groups<\/a>",
hmTitlePath:"Working with DW Spectrum > Users and Groups > LDAP Users and Groups",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">LDAP Users and Groups<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">LDAP integration allows a System to import <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Users <\/span><span class=\"f_BodyText\">and <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">User Groups <\/span><span class=\"f_BodyText\">from an LDAP Server.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Users must exist in the LDAP database object tree, match the base selection, and not be disabled in the LDAP Server to be imported.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">LDAP Groups and Users can be assigned Permissions and placed in any existing System Groups, except the Built-In Administrator Group (see &quot;<a href=\"configuring-users.html\" class=\"topiclink\">Configuring Users<\/a>&quot; and &quot;<a href=\"configure-groups.html\" class=\"topiclink\">Configuring Groups<\/a>&quot;).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">LDAP Groups have certain specifics in terms of configuration (see &quot;<a href=\"configure-groups.html\" class=\"topiclink\">Configuring Groups<\/a>&quot;).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\">LDAP Users can access the System using their LDAP username and password.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\">LDAP users will not be able to log in while the LDAP Server is not available (see &quot;<a href=\"ldap-sync-failure.html\" class=\"topiclink\">LDAP Sync Failure<\/a>&quot;).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\">The following LDAP Servers types are supported:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">Microsoft Active Directory,<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">Open LDAP Server,<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">JumpCloud.<\/span><\/p><p class=\"p_BodyTextIndent\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">IMPORTANT:<\/span><span class=\"f_BodyText\"> LDAP Users must have Resource Permissions granted (see &quot;<a href=\"roles_management.html\" class=\"topiclink\">Permissions Management<\/a>&quot;) or to be added to a <a href=\"built-in-groups.html\" class=\"topiclink\">Built-In Group<\/a> to do anything more than connect to a System.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Setting Up LDAP Integration<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">To import LDAP users and allow them to connect to the System, it is necessary to establish a connection between DW Spectrum and the LDAP Server. The LDAP server does not have to be a part of the same LAN the Media Server is on, but it must be available for the Media Server either by LAN or WAN.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">LDAP integration should be performed by, or in cooperation with, the <\/span><span class=\"f_BodyTextFirstIndent2\">Network (Domain) Administrator<\/span><span class=\"f_BodyTextFirstIndent2\">.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">LDAP over SSL may require certificates on both the LDAP and <\/span><span class=\"f_BodyText\">DW Spectrum<\/span><span class=\"f_BodyTextIndent\"> Servers.<\/span><\/p><p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: When configuring LDAP integration, do not specify the domain\'s base distinguished name (DN) as a search base, instead specify the organizational units (OU\'s) underneath the base DN because it is not possible to filter on OU membership, but you can filter on group membership. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyText\">To retrieve all users that are members of a specified group, filter on the <\/span><span class=\"f_CodeExample\">memberOf<\/span><span class=\"f_BodyText\"> attribute. For example: memberOf=CN=Security Users,CN=Users,DC=DOMAIN,DC=LOCAL.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Select <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Main Menu &gt; User Management<\/span><span class=\"f_BodyTextFirstIndent2\"> and go to the <\/span><span class=\"f_T_Interface_Elements\">LDAP<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> tab.<\/span><br \/>\n\r<span class=\"f_BodyTextIndent\">A <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Configure<\/span><span class=\"f_BodyTextIndent\"> button is displayed when no LDAP information exists in the System, otherwise the LDAP dialog displays the following summary information:<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\">Server,<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\">Server status,<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\">the last synchronization timestamp,<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\">the numbers of users and groups retrieved.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Click the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Edit <\/span><span class=\"f_BodyTextIndent\">button below the summary information to open the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">LDAP Connection Settings <\/span><span class=\"f_BodyTextIndent\">dialog.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Enter the following information (consult with your <\/span><span class=\"f_BodyText\">Network or Domain Administrator as needed<\/span><span class=\"f_BodyTextIndent\">):<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Host:<\/span><span class=\"f_BodyTextFirstIndent2\"> (ldap:\/\/ or ldaps:\/\/)<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"margin: 0.1250rem 0 0.1250rem 4.5625rem;\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">IMPORTANT:<\/span><span class=\"f_BodyTextFirstIndent2\"> If using a Server URL, it should be a <\/span><span class=\"f_BodyTextFirstIndent2\">fully qualified domain name (FQDN), sometimes also referred to as an absolute domain name<\/span><span class=\"f_BodyTextFirstIndent2\">. See <a href=\"https:\/\/en.wikipedia.org\/wiki\/Fully_qualified_domain_name\" target=\"_blank\" class=\"weblink\">https:\/\/en.wikipedia.org\/wiki\/Fully_qualified_domain_name<\/a> for details. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Login DN<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Password<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Options:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent2\">Use StarTLS<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent2\">Ignore LDAP Server certificate errors<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span><span class=\"f_BodyTextIndent\">Click the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Test<\/span><span class=\"f_BodyTextIndent\"> button to validate the server connection and credentials. One of the following message will be displayed:<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\">Connection OK<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\">Cannot connect to LDAP Server<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">5.<\/span><span class=\"f_BodyTextIndent\">Upon successful test results click the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Apply <\/span><span class=\"f_BodyTextIndent\">button to save the connection setting and return to the LDAP summary. Clicking <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Cancel<\/span><span class=\"f_BodyTextIndent\"> will discard all settings entered and exit the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">LDAP Connection Settings <\/span><span class=\"f_BodyTextIndent\">dialog.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">6.<\/span><span class=\"f_BodyTextIndent\">Click the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">+Add<\/span><span class=\"f_BodyTextIndent\"> button along the Search Bases heading to open the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Add Search Base <\/span><span class=\"f_BodyTextIndent\">dialog; enter the following information:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Name <\/span><span class=\"f_BodyTextIndent\">– often &quot;Users&quot;<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Base DN<\/span><span class=\"f_BodyTextIndent\"> – the starting point for LDAP searches and synchronization.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Filter <\/span><span class=\"f_BodyTextIndent\">– specific which Users and Groups from the Base DN to are allowed (optional).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">7.<\/span><span class=\"f_BodyTextIndent\">Click <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">OK<\/span><span class=\"f_BodyTextIndent\"> to close the dialog and return to the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">LDAP<\/span><span class=\"f_BodyTextIndent\"> tab of the User Management dialog.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">8.<\/span><span class=\"f_BodyTextIndent\">Click <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Apply<\/span><span class=\"f_BodyTextIndent\"> to save the Search Base parameters and retrieve User and Group information from the LDAP server. The Users and Groups count will update upon a successful retrieval.<\/span><\/p><p class=\"p_BodyTextIndent\"><img alt=\"Setting Up LDAP Integration - 1\" style=\"margin:0;width:38.0000rem;height:36.8750rem;border:none\" src=\".\/images\/hmfile_hash_101a7a1c.png\"\/><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">9.<\/span><span class=\"f_BodyTextIndent\">Optional – Click on Advanced Settings to review and change defaults for:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Synchronize Users<\/span><span class=\"f_BodyTextIndent\"> – Always or only at Login.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Sync Interval<\/span><span class=\"f_BodyTextIndent\"> – a value from 1 to 9999999 in seconds, minutes, or days.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Proxy Server<\/span><span class=\"f_BodyTextIndent\"> – select a specific Server to connect to the LDAP server, or Select <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Auto.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">In Auto mode, each server tries to connect to LDAP directly. If the connection fails, then every Server in the System will try to connect. If a specific Server is selected, but it is unavailable, the System defaults to Auto mode.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Users – Deselect <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Auto<\/span><span class=\"f_BodyTextIndent\"> to provide a specific value; use the checkbox to toggle the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">allowing insecure (digest) authentication for imported Users<\/span><span class=\"f_BodyTextIndent\">.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Groups – Deselect <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Auto<\/span><span class=\"f_BodyTextIndent\"> to provide a specific <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">objectClass <\/span><span class=\"f_BodyTextIndent\">value.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 3.3125rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Membership – Deselect <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Auto<\/span><span class=\"f_BodyTextIndent\"> to provide a specific <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Group Members Attribute<\/span><span class=\"f_BodyTextIndent\">.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Importing Users from LDAP Server<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">LDAP Users and Groups are imported immediately after the LDAP integration is completed and validated. Follow these steps to force an LDAP synchronization:<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Open <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Main Menu<\/span><span class=\"f_BodyTextFirstIndent2\"> &gt; <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">User Management &gt; LDAP<\/span><span class=\"f_BodyTextFirstIndent2\"> tab.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextFirstIndent2\">Below the User and Group count is the <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Last Sync<\/span><span class=\"f_BodyTextFirstIndent2\"> timestamp and a refresh icon.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextFirstIndent2\">Click the refresh icon to force LDAP synchronization. The refresh icon is not displayed when the sync interval in Advanced Settings is set to 1 minute or less.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span><span class=\"f_BodyTextIndent\">Once imported, LDAP users can be <\/span><span class=\"f_BodyText\">enabled or disabled (see &quot;<a href=\"disabling_user.html\" class=\"topiclink\">Enabling and Disabling Users<\/a>&quot;), and assigned User Permissions or placed in Permission Groups (see &quot;<a href=\"configuring-users.html\" class=\"topiclink\">Configuring Users&quot;<\/a>).<\/span><\/p><p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: LDAP users must successfully log into the Desktop Client one time before they can use the Web Admin.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Changing or reconfiguring LDAP Servers<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Changing or reconfiguring the LDAP Server integration can result in existing LDAP Users becoming invalid and thus disabled in the System. A warning banner and confirmation dialog is presented when LDAP integration changes may disrupt the validity of existing LDAP Users and Group.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Removing or Deleting an LDAP Server from the system<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Removing or deleting and LDAP Server connection that has been synchronized at least once will remove all LDAP User and Groups from the System. All System Permissions and Group membership configurations for LDAP User will be removed and all history for the LDAP Users will be removed from the <a href=\"viewing_users_actions_log_audi.html\" class=\"topiclink\">Audit Trail of User Actions<\/a>. This action cannot be undone.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Open <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">System Administration<\/span><span class=\"f_BodyTextFirstIndent2\"> &gt; <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">User Management &gt; <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">LDAP<\/span><span class=\"f_BodyTextFirstIndent2\"> tab.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextFirstIndent2\">Click on the <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Disconnect<\/span><span class=\"f_BodyTextFirstIndent2\"> button near the <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Edit<\/span><span class=\"f_BodyTextFirstIndent2\"> and <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Advanced Settings<\/span><span class=\"f_BodyTextFirstIndent2\"> buttons.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextFirstIndent2\">Confirm to <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Disconnect LDAP server and remove all LDAP Users and Groups<\/span><span class=\"f_BodyTextFirstIndent2\">.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">LDAP Warnings<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">The following warning may be displayed during LDAP configuration, testing, and update Synchronization<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Remove existing LDAP Users and Groups<\/span><span class=\"f_BodyTextIndent\">:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">This warning is displayed for any action that will force the removal of all existing LDAP Users from the system.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Disconnect LDAP Server<\/span><span class=\"f_BodyTextIndent\"> confirmation:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">This dialog is displayed before disconnecting and LDAP Server and removing all LDAP Users from the System.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">LDAP Server is offline:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">This banner is displayed in the User Management dialog for LDAP and includes a count of how many Users are currently unable to connect to the System.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">LDAP User Duplication:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">This banner is displayed in the User Management dialog when imported LDAP usernames conflict with existing usernames in the System. System accounts have priority and the duplicated LDAP usernames will are disabled.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">LDAP Digest Authentication:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">An informational dialog is presented when changing the LDAP Digest Authentication settings if some Users will also need their User Configuration Settings changed.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
