hmLoadTopic({
hmKeywords:"",
hmTitle:"Analytics Event",
hmDescription:"Occurs when DW Spectrum Server receives a special HTTP request from a device with built-in video analytics. If a camera has analytics enabled, DW Spectrum can render visual...",
hmPrevLink:"events_available_in_vms.html",
hmNextLink:"analytics-object-detected.html",
hmParentLink:"events_available_in_vms.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_events_and_actions.html\">Event Rules<\/a> &gt; <a href=\"events_available_in_vms.html\">Tracked Events<\/a>",
hmTitlePath:"Working with DW Spectrum > Event Rules > Tracked Events > Analytics Event",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Analytics Event<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Occurs when DW Spectrum Server receives a special HTTP request from a device with built-in video analytics. If a camera has analytics enabled, <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">DW Spectrum can render visual displays in layout for the various types of analytics data received. Event metadata is also captured, and can be searched, filtered, and further analyzed. <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">IMPORTANT: <\/span><span class=\"f_BodyTextIndent\">Analytics must be configured in the camera first in order to be detected by <\/span><span class=\"f_BodyText\">DW Spectrum. <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">For example, <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">video analytics can detect when a vehicle has entered a certain area, zoom in on the license plate, and then perform license plate recognition. The corresponding event in<\/span><span class=\"f_BodyText\"> DW Spectrum could render <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">a bounding box of one color around the car, a bounding box of another color around the license plate, and trigger an Email alert to security personnel. See &quot;<a href=\"analytics-object-detected.html\" class=\"topiclink\">Analytics Object Detected<\/a>&quot; for more details about Analytics Events that specifically involve object detection (i.e. temperature detection is an Analytics Event with no object detection, but face recognition is an Analytics Event involving object detection).<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Any number of video analytics devices can be connected the System<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">, and for each device any number of video analytic types can be enabled.<\/span><span class=\"f_BodyText\"> <\/span><span class=\"f_BodyText\">Visualizations are captured and displayed as a bounding box in a user-specified color for each event or as a point for objects with a coordinate but no size. <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">Once defined, an analytics event can be searched and filtered by entity type (notifications, Bookmarks, events, motion, detected objects), by area as with motion search, by class or by attribute using unified text search of the Caption and Description fields, or by date interval. A counter shows the number of results that match the search criteria.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To configure an Analytics Event<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">Use the camera web page to confirm that analytics detection is properly configured and enabled in the device(s) you plan to use<\/span><span class=\"f_BodyText\">. <\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyTextFirstIndent2\">: Some cameras can have their analytics detection configured in the DW Spectrum desktop client. See <a href=\"plugins-and-analytics.html\" class=\"topiclink\">Plugins and Analytics<\/a> for more information.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">Open <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: bold;\">Event Rules<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> and click the <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: bold;\">Add<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> button to create a new rule.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">Select <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: bold;\">Analytics Event<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> from the <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: bold;\">When<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> field.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">Click on the <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: bold;\">At<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> field to select the device(s) that will be generating the third party analytics for the rule. In the <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-style: italic;\">Select Devices<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> list, cameras that do not support analytics are highlighted in red. <\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyTextFirstIndent2\">: <\/span><span class=\"f_BodyTextFirstIndent2\">Analytics integration works with certain <\/span><span class=\"f_BodyTextIndent\">camera models only, and event types differ from camera to camera. A warning notification will open if one or more of the selected cameras does not support analytics. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_Normal\" style=\"font-size:1.10rem; font-family: \'Calibri\';display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">5.<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">Choose the <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: bold;\">Event Type<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> that will trigger the rule.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note:<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> Each device will have a different set of available triggers depending on the analytic capabilities provided by the manufacturer. Only those available for the selected devices will be listed. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">6.<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">Optionally, use the <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-style: italic;\">Caption<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> and <\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-style: italic;\">Description<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> fields to enter or filter attributes or metadata provided by the analytics device. Entries in these<\/span><span class=\"f_BodyText\"> fields should match the corresponding fields in the HTTP request and are case sensitive. If the field is empty, it will always be considered a match.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Caption<\/span><span class=\"f_BodyTextIndent\"> – Op<\/span><span class=\"f_BodyTextFirstIndent2\">tional class value used to identify object type.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Description<\/span><span class=\"f_BodyTextFirstIndent2\"> – O<\/span><span class=\"f_BodyText\">ptional attribute value <\/span><span class=\"f_BodyTextFirstIndent2\">used to distinguish objects within a class.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Advanced Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"setting_up_schedule_for_tracki.html\" class=\"topiclink\">Event Scheduling<\/a><\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Why Event may work incorrectly<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\">Request is filtered out. Edit or clear the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Caption<\/span><span class=\"f_BodyTextIndent\"> and <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Description<\/span><span class=\"f_BodyTextIndent\"> fields and trigger the event again.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"global_notifications.html\" class=\"topiclink\">Global notification<\/a> for this event is disabled.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
