hmLoadTopic({
hmKeywords:"",
hmTitle:"Analyzing and Predicting Storage Usage",
hmDescription:"Due to differing stream bitrates, different cameras may require different amounts of storage space to save data for the same time interval. DW Spectrum uses special algorithms...",
hmPrevLink:"restoring_broken_archive.html",
hmNextLink:"monitoring_media_servers.html",
hmParentLink:"configuring_media_servers_additional_settings_(ad.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_media_servers_additional_settings_(ad.html\">Configuring Server Settings<\/a>",
hmTitlePath:"Working with DW Spectrum > Configuring Server Settings > Analyzing and Predicting Storage Usage",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Analyzing and Predicting Storage Usage<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Due to differing stream bitrates, different cameras may require different amounts of storage space to save data for the same time interval. DW Spectrum uses special algorithms to balance storage needs so that cameras with high storage needs do not prevent archive from other cameras from being recorded. DW Spectrum storage analytics are available in the Desktop Client to help users estimate and predict storage usage.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: <\/span><span class=\"f_BodyText\">For any given camera, Administrators<\/span><span class=\"f_BodyText\"> have the option of setting a minimum or maximum number of days that data is archived (see &quot;<a href=\"configuring-maxi-and-min-archive-storage.html\" class=\"topiclink\">Configuring Minimum and Maximum Archive Storage<\/a>&quot;).<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Some common ways storage analysis can be used:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Identify camera(s) that stream at extremely high bitrates.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Estimate the amount of time a Server can store data from a given device in days and hours.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Assess the storage space that each camera consumes.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Predict the amount of time a Server can store recordings if additional storage is added.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To View Storage Statistics for a Server<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Open<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> Server Settings<\/span><span class=\"f_BodyTextIndent\"> from the Server context menu and go to the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Storage Analytics<\/span><span class=\"f_BodyTextIndent\"> tab. T<\/span><span class=\"f_BodyText\">he <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Current Statistics<\/span><span class=\"f_BodyText\"> tab shows t<\/span><span class=\"f_BodyTextIndent\">he total number of cameras, total space used for archive and total streaming rate at the bottom of the list, and there is a link to open the Server web page on the lower left corner of the page.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><img alt=\"Analyzing Storage - 1\" style=\"margin:0;width:40.6250rem;height:16.3750rem;border:none\" src=\".\/images\/hmfile_hash_1d50e1e8.jpg\"\/><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Each of the columns can be sorted in ascending or descending order:<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Camera<\/span><span class=\"f_BodyTextFirstIndent2\"> – Camera name.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Space<\/span><span class=\"f_BodyTextFirstIndent2\"> – the amount of storage currently consumed by recordings from a given camera.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Calendar Days<\/span><span class=\"f_BodyTextFirstIndent2\"> – the amount of time recorded data is available for this camera.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Current Bitrate<\/span><span class=\"f_BodyTextFirstIndent2\"> – the current bitrate at which the camera is streaming.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To Predict Storage Needed for a Server<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Forecast data is only available for Cameras with recording enabled.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Click on the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Forecast for Full Storage Usage<\/span><span class=\"f_BodyTextIndent\"> tab i<\/span><span class=\"f_BodyTextIndent\">n<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> Server Settings<\/span><span class=\"f_BodyTextIndent\"> &gt; <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Storage Analytics<\/span><span class=\"f_BodyTextIndent\">. <\/span><span class=\"f_BodyTextIndent\">The total number of cameras and total space required for archive is shown at the bottom of the list.<\/span><br \/>\n\r<span class=\"f_BodyTextIndent\">Each of the columns can be sorted in ascending or descending order:<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Camera<\/span><span class=\"f_BodyTextFirstIndent2\"> – Camera name.<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: -0.3750rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\" style=\"font-style: italic;\">Space<\/span><span class=\"f_BodyTextFirstIndent3\"> – the amount of storage that will be required.<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: -0.3750rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\" style=\"font-style: italic;\">Calendar Days<\/span><span class=\"f_BodyTextFirstIndent3\"> – the duration of time that there is for the archive.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">In the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Base forecast on data recorded during<\/span><span class=\"f_BodyTextIndent\"> field, set the window of past history that will be used to calculate future storage needs from the options:<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Last 5 minutes.<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: -0.3750rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\" style=\"font-style: italic;\">Last 60 minutes.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Last 24 hours.<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: -0.3750rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\" style=\"font-style: italic;\">Longest period available.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyText\">Use the <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Additional Storage<\/span><span class=\"f_BodyText\"> field or slider to select an amount of storage that would be added, in Terabytes (TB). <\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">The amount of space and archive duration will update as values in the two settings change.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: Displayed statistics will periodically refresh<\/span><span class=\"f_BodyTextIndent\"> – a manual Refresh button is provided along the right side of the header menu.<\/span><\/p>\n\r"
})
