hmLoadTopic({
hmKeywords:"",
hmTitle:"Devices Disconnected (default)",
hmDescription:"Occurs if a device is disconnected for whatever reason (network issue, device malfunction, etc.). This is a default event.",
hmPrevLink:"archive_backup_finished.html",
hmNextLink:"camera_ip_conflict.html",
hmParentLink:"events_available_in_vms.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_events_and_actions.html\">Event Rules<\/a> &gt; <a href=\"events_available_in_vms.html\">Tracked Events<\/a>",
hmTitlePath:"Working with DW Spectrum > Event Rules > Tracked Events > Devices Disconnected (default)",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Devices Disconnected (default)<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Occurs if a <\/span><span class=\"f_BodyText\">device<\/span><span class=\"f_BodyText\"> is disconnected for whatever reason (network issue, <\/span><span class=\"f_BodyText\">device<\/span><span class=\"f_BodyText\"> malfunction, etc.). This is a default event.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Devices are considered disconnected if no data is received for 10 seconds. <\/span><span class=\"f_BodyText\">If a device is experiencing network issues for over a minute, then <\/span><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_BodyText\"> appears next to it in the Resource Panel.<\/span><span class=\"f_BodyText\"> Once data is received from the <\/span><span class=\"f_BodyText\">device,<\/span><span class=\"f_BodyText\"> the status is automatically changed back to Online. <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Additional related <\/span><span class=\"f_BodyText\">events<\/span><span class=\"f_BodyText\"> may occur that can help to investigate the issue:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\"><a href=\"network_issue.html\" class=\"topiclink\">Network Issue<\/a><\/span><span class=\"f_BodyTextIndent\"> – Indicates the network is unable to transfer data between<\/span><span class=\"f_BodyTextIndent\"> the device<\/span><span class=\"f_BodyTextIndent\"> and <\/span><span class=\"f_BodyTextIndent\">server, potentially the reason a<\/span><span class=\"f_BodyTextIndent\"> device goes offline.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\"><a href=\"media_server_failure.html\" class=\"topiclink\">Server Failure<\/a><\/span><span class=\"f_BodyTextIndent\"> – If a <\/span><span class=\"f_BodyTextIndent\">server<\/span><span class=\"f_BodyTextIndent\"> is down, all hosted devices will appear offline.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\"><a href=\"camera_ip_conflict.html\" class=\"topiclink\">Camera IP Conflict<\/a><\/span><span class=\"f_BodyTextIndent\"> – If another <\/span><span class=\"f_BodyTextIndent\">camera<\/span><span class=\"f_BodyTextIndent\"> with the same IP address enters the network, one of these two <\/span><span class=\"f_BodyTextIndent\">cameras<\/span><span class=\"f_BodyTextIndent\"> will go offline.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\"><a href=\"media_servers_conflict.html\" class=\"topiclink\">Server Conflict<\/a><\/span><span class=\"f_BodyTextIndent\"> – If different servers on the same network access and pull data from the same <\/span><span class=\"f_BodyTextIndent\">cameras. S<\/span><span class=\"f_BodyTextIndent\">ome <\/span><span class=\"f_BodyTextIndent\">cameras<\/span><span class=\"f_BodyTextIndent\"> may drop offline because they are not able to provide several streams simultaneously.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Basic Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">At<\/span><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextIndent\">– Click in this field to <a href=\"selection_lists_in_event_rules.html\" class=\"topiclink\">select devices<\/a><\/span><span class=\"f_BodyTextIndent\"> to monitor, or use <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">&lt;Any Device&gt;<\/span><span class=\"f_BodyTextIndent\"> to monitor <\/span><span class=\"f_BodyTextIndent\">all <\/span><span class=\"f_BodyTextIndent\">devices.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Advanced Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"setting_up_schedule_for_tracki.html\" class=\"topiclink\">Event Scheduling<\/a><\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Why Event may work incorrectly<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Too many devices are monitored, triggering too many events.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Devices being monitored are offline.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Action<\/span><span class=\"f_BodyTextIndent\"> is not configured properly. <\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"global_notifications.html\" class=\"topiclink\">Global notification<\/a> for this event is disabled.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
