hmLoadTopic({
hmKeywords:"",
hmTitle:"Configuring Storage for Analytical Data",
hmDescription:"By default, DW Spectrum utilizes the largest available local storage (non-system) for storing analytical data. However, there may be instances where you would prefer to use a...",
hmPrevLink:"configuring_redundant_storage_.html",
hmNextLink:"restoring_broken_archive.html",
hmParentLink:"configuring_redundant_storage_.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_media_servers_additional_settings_(ad.html\">Configuring Server Settings<\/a> &gt; <a href=\"configuring_redundant_storage_.html\">Configuring Backup and Redundant Storage<\/a>",
hmTitlePath:"Working with DW Spectrum > Configuring Server Settings > Configuring Backup and Redundant Storage > Configuring Analytics Storage",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Configuring Storage for Analytical Data<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">By default, <\/span><span class=\"f_BodyTextIndent\">DW Spectrum<\/span><span class=\"f_BodyText\"> utilizes the largest available local storage (<\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">non-system<\/span><span class=\"f_BodyText\">) for storing analytical data. However, there may be instances where you would prefer to use a different drive for this purpose. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\" style=\"background-color: #ffffff;\">&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold; background-color: #ffffff;\">Note<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">: Network (CIFS\/Samba\/NFS) cannot be used for storing analytic data.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Particularly in systems with a high volume of events, it proves advantageous to employ a faster and dedicated drive specifically for this purpose. For example, <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">SSD<\/span><span class=\"f_BodyText\"> or <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">NVMe<\/span><span class=\"f_BodyText\"> drives offer significantly faster read\/write speeds compared to common HDDs, enabling them to effectively handle the incoming analytic events.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyTextIndent\">DW Spectrum enables you to predict the storage usage based on the current data recorded. See &quot;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff; text-decoration: underline;\"><a href=\"analyzingandanticipatingstorageusage.html\" class=\"topiclink\">Analyzing and Predicting Storage Usage<\/a><\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&quot; for details.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To change the Analytics storage location:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Navigate to the Server Settings menu, tab Storage management.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Hover with your mouse over the available drives and select Store analytics data.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">If any data has been recorded to the previous drive, decide to <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Delete<\/span><span class=\"f_BodyTextIndent\"> or <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Keep the current analytics data<\/span><span class=\"f_BodyTextIndent\">.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff; text-decoration: underline;\">To Fix the Analytics Storage Database Error<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">The error “Storage Issue: Analytics storage DB error. Insufficient permissions on the mount point” typically occurs on <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Ubuntu<\/span><span class=\"f_BodyTextIndent\"> servers when trying to store analytics data on a drive that the DW Spectrum Server application is not able to properly access due to having inadequate permissions. Your Server is likely missing the following permissions to the storage drive:<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">Read (the capability to read the contents of the file)<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.0625rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Execute (the capability to execute a file or view the contents of a directory)<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Fix the storage issue by enabling the option <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">forceAnalyticsDbStoragePermissons<\/span><span class=\"f_BodyTextIndent\"> in the DW Spectrum Web Admin interface. This option grants the DW Spectrum Server application the necessary read and execute permissions for that storage drive.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">By default, the option is enabled, but it may not be enabled if you have upgraded from a previous version. To enable it manually:<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Open the <\/span><span class=\"f_BodyText\">DW Spectrum<\/span><span class=\"f_BodyTextFirstIndent2\"> Web Admin advanced page<\/span><span class=\"f_BodyText\"> (i.e., http:\/\/&lt;server ip&gt;:&lt;server port&gt;\/#\/settings\/advanced).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Login to as an administrator or power user.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Check the box for <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">forceAnalyticsDbStoragePermissons<\/span><span class=\"f_BodyTextIndent\">.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_BodyText\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span><span class=\"f_BodyTextIndent\">Click the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Save<\/span><span class=\"f_BodyTextIndent\"> button at the bottom of the page.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\" style=\"background-color: #ffffff;\">&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold; background-color: #ffffff;\">Note<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">: If the Server still does not have the appropriate permissions after enabling&nbsp;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">forceAnalyticsDbStoragePermissions<\/span><span class=\"f_BodyTextIndent\">, the error<\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyText\">“Storage Issue: Analytics storage DB error. Insufficient permissions on the mount point” will still appear in the Notification Panel.<\/span><\/p>\n\r"
})
