hmLoadTopic({
hmKeywords:"",
hmTitle:"Configuring Archive Storage",
hmDescription:"DW Spectrum provides the ability to set a maximum and minimum storage duration for the archive of any given camera, from the current time going backwards.",
hmPrevLink:"recording_modes.html",
hmNextLink:"copying_recording_schedule_fro.html",
hmParentLink:"editing_recording_schedule.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_cameras.html\">Device Management<\/a> &gt; <a href=\"setting_up_cameras_and_devices.html\">Setting Up Cameras and Devices<\/a> &gt; <a href=\"setting_up_recording_schedule_(admin_only).html\">Recording<\/a> &gt; <a href=\"editing_recording_schedule.html\">Setting a Recording Schedule<\/a>",
hmTitlePath:"Working with DW Spectrum > Device Management > Setting Up Cameras and Devices > Recording > Setting a Recording Schedule > Configuring Minimum and Maximum Archive Storage",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Configuring Archive Storage<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">DW Spectrum provides the ability to set a maximum and minimum storage duration for the archive of any given camera, from the current time going backwards.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Before you use a<\/span><span class=\"f_BodyText\" style=\"font-style: italic;\"> Keep Archive For<\/span><span class=\"f_BodyText\"> setting, it is important to understand the impact it will have. The default <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Auto<\/span><span class=\"f_BodyText\"> setting means that archived footage for a given camera is treated according to the standard algorithm – the oldest data is deleted first. No<\/span><span class=\"f_BodyTextFirstIndent2\"> controls are placed on when or which archived footage is deleted.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">The <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Min<\/span><span class=\"f_BodyText\"> and <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Max<\/span><span class=\"f_BodyText\"> fields assign priority to a given camera – high priority for Min, low priority for Max. If more than one camera is assigned high or low priority, storage results may not be predictable. Typically the <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Min<\/span><span class=\"f_BodyTextFirstIndent2\"> setting is used for environments with limited storage capacity and a few high-importance cameras, or when <\/span><span class=\"f_BodyText\">a regulation requires that certain footage be stored for a minimum amount of time. <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Max<\/span><span class=\"f_BodyText\"> is typically used for environments where storage is limited and there is no need to store records beyond a certain age from certain cameras. <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">It is not possible to enter a Max value less than the Min value, and vice versa.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Minimum (Days. Hours, Minutes)<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Min<\/span><span class=\"f_BodyTextIndent\"> sets a <\/span><span class=\"f_BodyText\">minimum archive length, in<\/span><span class=\"f_BodyTextIndent\"> number of days<\/span><span class=\"f_BodyText\" style=\"text-decoration: underline;\">. hours or minutes<\/span><span class=\"f_BodyTextIndent\"> from the current date, for which DW Spectrum gives highest priority to retention of records from a given camera over retention of records from any camera that has the default (<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Auto<\/span><span class=\"f_BodyTextIndent\">) archive setting. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">For example, a <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Min. Days <\/span><span class=\"f_BodyTextIndent\">value of 120 for a given camera means DW Spectrum will attempt to preserve the past 120 days of records from that camera. <\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">IMPORTANT:<\/span><span class=\"f_BodyText\"> <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Be careful when setting a minimum days value.<\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyText\">I<\/span><span class=\"f_BodyTextIndent\">f more than one camera is assigned a <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Min. Days<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic; font-weight: bold;\"> <\/span><span class=\"f_BodyTextIndent\">value, those cameras will have the same priority level – in which case storage results cannot be entirely guaranteed for any of them. <\/span><span class=\"f_BodyText\">If there is <\/span><span class=\"f_BodyText\">insufficient storage space<\/span><span class=\"f_BodyText\">, in order to retain footage as specified with<\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Min<\/span><span class=\"f_BodyText\">, <\/span><span class=\"f_BodyText\">DW Spectrum will first delete records from cameras that<\/span><span class=\"f_BodyText\"> do not have a minimum archive length set, and then the system may stop recording incoming signals from low and average priority Cameras. <\/span><span class=\"f_BodyText\">I<\/span><span class=\"f_BodyText\">f storage space is at capacity, <\/span><span class=\"f_BodyText\">no other camera streams will be recorded.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Maximum (Days. Hours, Minutes)<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Max<\/span><span class=\"f_BodyTextIndent\"> sets an archive duration after which <\/span><span class=\"f_BodyTextIndent\">records will not be saved for a given camera.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyTextIndent\" style=\"text-decoration: underline;\">To Configure Minimum and Maximum Storage Duration<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Go to the camera\'s context menu from <\/span><span class=\"f_BodyTextIndent\">the Resource Panel or <\/span><span class=\"f_BodyTextIndent\">layout <\/span><span class=\"f_BodyTextIndent\">and open<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> Camera Settings<\/span><span class=\"f_BodyTextIndent\"> &gt; <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Recording<\/span><span class=\"f_BodyTextIndent\"> tab <\/span><span class=\"f_BodyTextIndent\">(or<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\"> <\/span><span class=\"f_BodyTextIndent\">the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">General<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\"> <\/span><span class=\"f_BodyTextIndent\">tab for <a href=\"virtual_camera.html\" class=\"topiclink\">Virtual Cameras<\/a>).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyText\">In the <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Fixed Archive Length<\/span><span class=\"f_BodyText\"> section, uncheck the <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Auto<\/span><span class=\"f_BodyText\"> checkbox.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">In <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Min<\/span><span class=\"f_BodyTextIndent\">,<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyTextIndent\">enter the amount of time for which archive should be retained. <\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span><span class=\"f_BodyTextIndent\">In <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Max<\/span><span class=\"f_BodyTextIndent\">, enter the <\/span><span class=\"f_BodyTextIndent\">amount of time <\/span><span class=\"f_BodyTextIndent\">after which archive will be automatically deleted from storage.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">5.<\/span><span class=\"f_BodyTextIndent\">Click <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Apply<\/span><span class=\"f_BodyTextIndent\"> to accept, <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">OK<\/span><span class=\"f_BodyTextIndent\"> to save and close the dialog, or <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Cancel<\/span><span class=\"f_BodyTextIndent\"> to discard changes.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
