hmLoadTopic({
hmKeywords:"",
hmTitle:"Configuring Device Using Web Page",
hmDescription:"For all camera vendors, DW Spectrum provides direct access to a camera\'s web page where users can configure the camera\'s settings without leaving the Desktop Client. If the...",
hmPrevLink:"configuring_proprietary_camera_parameters.html",
hmNextLink:"upgrading_firmware_for_a_camer.html",
hmParentLink:"working_with_advanced_settings.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_cameras.html\">Device Management<\/a> &gt; <a href=\"setting_up_cameras_and_devices.html\">Setting Up Cameras and Devices<\/a> &gt; <a href=\"working_with_advanced_settings.html\">Advanced Device Settings<\/a>",
hmTitlePath:"Working with DW Spectrum > Device Management > Setting Up Cameras and Devices > Advanced Device Settings > Configuring Device Using Web Page",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Configuring Device Using Web Page<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">For <\/span><span class=\"f_BodyText\">all camera vendors, <\/span><span class=\"f_BodyText\">DW Spectrum provides direct access to a camera\'s web page where users can configure the camera\'s settings without leaving the Desktop Client. If the <\/span><span class=\"f_BodyTextIndent\">device cannot be accessible from the computer Desktop Client is running on<\/span><span class=\"f_BodyText\">, <\/span><span class=\"f_BodyTextIndent\">DW Spectrum<\/span><span class=\"f_BodyText\"> Server acts like a proxy Server to retrieve the device web page content and display it within the Desktop Client.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyTextIndent\">: Only camera web pages that work in Chrome are supported.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">In some cases, if a custom integration with a camera has been implemented, DW Spectrum<\/span><span class=\"f_BodyText\"> pulls proprietary<\/span><span class=\"f_BodyText\"> device parameters such as authorization, network settings, and <\/span><span class=\"f_BodyText\">displays controls <\/span><span class=\"f_BodyText\">into <\/span><span class=\"f_BodyText\">the Desktop Client where they can be <\/span><span class=\"f_BodyText\">configured directly. See the below image for one example of such a web page (can vary depending on the manufacturer).<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"Configuring Device Using Web Page - 1\" style=\"margin:0;width:46.8750rem;height:40.0625rem;border:none\" src=\".\/images\/hmfile_hash_2bb94103.png\"\/><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">By default, the web page is available on the standard port (80). In case of using a non-standard port, it should be configured in on a device\'s &quot;Expert&quot; tab (see &quot;<a href=\"working_around_device_issues_e.html\" class=\"topiclink\">Device Expert Tab<\/a>&quot;).<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">From the General tab<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyText\">Select a camera and o<\/span><span class=\"f_BodyTextIndent\">pen the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Camera Settings<\/span><span class=\"f_BodyTextIndent\"> &gt; <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">General<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> tab<\/span><span class=\"f_BodyTextIndent\">.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">If the device requires authentication, enter camera credentials in the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Authentication<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\"> <\/span><span class=\"f_BodyTextIndent\">section (s<\/span><span class=\"f_BodyTextIndent\">ee &quot;<a href=\"configuring_camera_authentication_(admin_only).html\" class=\"topiclink\">Configuring Device Authentication<\/a>&quot;). <\/span><span class=\"f_BodyText\">You must have the &quot;Edit camera settings&quot; permission to perform this function. <\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Click on the <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Web Page<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> link. <\/span><span class=\"f_BodyTextIndent\">The browser will open the device’s web page. From here you can control settings such as display size, JPEG refresh rate, PTZ and focus speed, etc.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: To check device accessibility, press the <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Ping<\/span><span class=\"f_T_Interface_Elements\"> <\/span><span class=\"f_BodyText\">button prior to opening the web page<\/span><span class=\"f_BodyText\">.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">From the<\/span><span class=\"f_BodyText\" style=\"text-decoration: underline;\"> Web Page tab<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Select a camera and open <\/span><span class=\"f_BodyTextIndent\">the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Camera Settings<\/span><span class=\"f_BodyTextIndent\"> &gt; <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Web Page<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> tab<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">The device\'s web page will open within that tab.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Enter<\/span><span class=\"f_BodyText\"> authentication parameters if required.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
