hmLoadTopic({
hmKeywords:"",
hmTitle:"Configuring Multi-Server Environment",
hmDescription:"DW Spectrum allows many servers to work together, in one or more Systems, for complete scalability.",
hmPrevLink:"session-and-digest-authentication.html",
hmNextLink:"join_server_from_different_sys.html",
hmParentLink:"index.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a>",
hmTitlePath:"Working with DW Spectrum > Configuring Multi-Server Environment",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Configuring Multi-Server Environment<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">DW Spectrum allows many servers to work&nbsp;<\/span><span class=\"f_BodyText\">together, in one or more Systems, for complete<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;scalability.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">Servers are identified and merged according to a&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold; background-color: #ffffff;\">localSystemId<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;value that is assigned to a Server during initial configuration in the Setup Wizard. If &quot;Setup New System&quot; is selected in the Setup Wizard, a new localSystemId is generated. If &quot;Add to Existing System&quot; is selected, the localSystemId is taken from the remote System.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">If servers are in different subnets, it is necessary to specify the other server\'s IP to allow them to merge in separate networks (behind NAT or over the Internet).<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">When servers are merged, they constantly synchronize all settings <\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">so it doesn\'t matter which Server the client is connected to. If video from a remote Server is requested, the client tries to connect directly to it and if it fails, the current Server will act as a proxy between the client and the Server with the video data.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">Licenses are combined as well: if 4 licenses were activated on Server A and 10 licenses&nbsp;<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">were activated on Server B, the System will have 14 licenses total after the servers are merged.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">The maximum recommended scale of a single System, based on lab testing results, is approximately 100 servers and 1,000 users, but can vary significantly based on System design choices and operating environment.&nbsp;<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">Is recommended to contact your Support Team for assistance with large scale deployments and performance optimizations.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">The following topics his section describes how to manage multi-Server environments to maintain maximum System reliability and performance:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\"><a href=\"join_server_from_different_sys.html\" class=\"topiclink\">Moving One Server to a Different System<\/a>.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\"><a href=\"merge_all_servers_to_another_s.html\" class=\"topiclink\">Merging Systems<\/a>.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\"><a href=\"split_server_to_different_syst.html\" class=\"topiclink\">Detaching a Server<\/a>.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\"><a href=\"configuring_failover.html\" class=\"topiclink\">Configuring Failover<\/a>.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\"><a href=\"configuring_routing_within_mul.html\" class=\"topiclink\">Configuring Routing in a Multi-Server Environment<\/a>.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\"><a href=\"configuring_time_synchronizati.html\" class=\"topiclink\">Configuring Time Synchronization in a Multi-Server Environment<\/a>.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
