hmLoadTopic({
hmKeywords:"",
hmTitle:"Bookmark",
hmDescription:"Creates a Bookmark in the archive of one or more cameras when an event occurs. See Using Bookmarks for details about Bookmarks.",
hmPrevLink:"actions_that_vms_can_.html",
hmNextLink:"trigger_camera_output.html",
hmParentLink:"actions_that_vms_can_.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_events_and_actions.html\">Event Rules<\/a> &gt; <a href=\"actions_that_vms_can_.html\">Available Actions<\/a>",
hmTitlePath:"Working with DW Spectrum > Event Rules > Available Actions > Bookmark",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Bookmark<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_Normal\"><span class=\"f_BodyText\">Creates a Bookmark<\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyText\">in the archive of one or more cameras <\/span><span class=\"f_BodyText\">when <\/span><span class=\"f_BodyText\">an event<\/span><span class=\"f_BodyText\"> occurs. See <\/span><span class=\"f_BodyText\"><a href=\"using_bookmarks.html\" class=\"topiclink\">Using Bookmarks<\/a> for details about Bookmarks.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: Recording <\/span><span class=\"f_BodyText\">must be enabled on the selected cameras for Bookmarks to be saved.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">A Bookmark<\/span><span class=\"f_BodyText\"> is automatically named with the syntax <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">&lt;Event&gt; on &lt;Device&gt;<\/span><span class=\"f_BodyText\">.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Basic Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">At<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyTextFirstIndent2\">– C<\/span><span class=\"f_BodyTextIndent\">amera(s) for which Bookmarks will be recorded<\/span><span class=\"f_BodyTextIndent\">. To specify cameras see &quot;<a href=\"selection_lists_in_event_rules.html\" class=\"topiclink\">Selection Lists in Event Rules<\/a>&quot;. At least one device must be selected.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_T_Interface_Elements\">Also set on source camera<\/span><span class=\"f_BodyTextIndent\"> – Check<\/span><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextIndent\">to set the Bookmark on the camera selected in the event.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Advanced Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Fixed Duration<\/span><span class=\"f_BodyTextIndent\"> – The duration of the Bookmark. It applies to continuous events only, such as those with the Starts or Stops attribute set (e.g., motion on camera, input signal on device, etc.). If unchecked, the Bookmark will continue until the event ends.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Pre-Recording <\/span><span class=\"f_BodyTextIndent\">– If checked, use to specify an amount of time to include in the Bookmark before the event occurs. <\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Post-Recording <\/span><span class=\"f_BodyTextIndent\">– If checked, use to specify an amount of time to include in the Bookmark after the event occurs.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Tags <\/span><span class=\"f_BodyTextIndent\">– Optional descriptors that can be added to help identify and search for Bookmarks.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">May be caused by<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">All <\/span><span class=\"f_BodyTextIndent\">Events<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"notifications.html\" class=\"topiclink\">Notifications<\/a> with <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Force Acknowledgment<\/span><span class=\"f_BodyTextIndent\"> enabled will <\/span><span class=\"f_BodyTextIndent\">create the Bookmark once acknowledgment is complete.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Why Action may work incorrectly<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Recording <\/span><span class=\"f_BodyTextIndent\">is not enabled <\/span><span class=\"f_BodyTextIndent\">on a selected <\/span><span class=\"f_BodyTextIndent\">camera<\/span><span class=\"f_BodyTextIndent\"> (see &quot;<a href=\"editing_recording_schedule.html\" class=\"topiclink\">Setting a Recording Schedule<\/a>&quot;).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Event<\/span><span class=\"f_BodyTextIndent\"> is not configured properly.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
