hmLoadTopic({
hmKeywords:"",
hmTitle:"Expired and Invalid License Keys",
hmDescription:"Under some circumstances, a license may become invalid. For instance, when a Server is removed from the System or goes offline, the licenses tied to the hardware ID of that...",
hmPrevLink:"activating_licenses.html",
hmNextLink:"configuring-secure-connections.html",
hmParentLink:"obtaining_and_activating_vms_licenses.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"system-wide_configurations.html\">System-Wide Configurations<\/a> &gt; <a href=\"services-and-licenses.html\">Services and Licenses<\/a> &gt; <a href=\"obtaining_and_activating_vms_licenses.html\">DW Spectrum Licenses<\/a>",
hmTitlePath:"Working with DW Spectrum > System-Wide Configurations > Services and Licenses > DW Spectrum Licenses > Expired and Invalid License Keys",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Expired and Invalid License Keys<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Under some circumstances, a license may become invalid. For instance, when <\/span><span class=\"f_BodyTextIndent\">a Server is removed from the System or goes offline, the licenses tied to the hardware ID of that Server will become invalid. <\/span><span class=\"f_BodyText\">When the Server is back online or reconnected to the System, the licenses will be active again without configuration.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">However, if a server<\/span><span class=\"f_BodyTextIndent\"> change results in a hardware ID update, all licenses tied to the previous hardware ID will become invalid and can only be activated on the new hardware ID by contacting support. If a hardware change is planned, the best approach is to contact support prior to the update so licenses can be intentionally deactivated before the hardware change, while they are still active and valid, and reactivated once the new hardware ID is established. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: <\/span><span class=\"f_BodyTextIndent\">A trial license<\/span><span class=\"f_BodyTextIndent\"> cannot be deactivated nor reactivated once it expires.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyTextIndent\">Under certain conditions, such as when a recording license is invalidated, or when a Server fails in a failover-enabled system (see <a href=\"configuring_failover.html\" class=\"topiclink\">Configuring Failover<\/a>), a 30-day grace period is granted to prevent gaps in recording and allow you enough time to resolve the Server or license issue. Once the original Server comes back online, or the license issue has been resolved, the recording will continue normally with the original license(s). <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyTextIndent\">Similar functionality exists for Video Wall licenses, where a seven day grace period is granted to prevent any interruptions in the Video Wall and allow you enough time to resolve the license issue (see <a href=\"video_wall_management.html\" class=\"topiclink\">Video Wall Mode<\/a>).<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To Deactivate a License<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Users can deactivate and move a license a maximum of 3 times. The operation must be performed from the Desktop Client and requires an active Internet connection in order to execute. Trial licenses cannot be deactivated.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Go to <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Licenses<\/span><span class=\"f_BodyTextFirstIndent2\"> tab in <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">System Administration<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyText\">Select a license, click <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Deactivate<\/span><span class=\"f_BodyText\"> and confirm the action in the dialog that opens.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyText\">Enter your name, Email address, and select the reason for deactivation from drop-down list to confirm and explain the action.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">It will now be possible to activate this license key on another computer.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To Remove a License<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">If you are absolutely certain a license is no longer needed, it is possible to remove it. Only invalid (red) licenses can be removed.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Go to <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Licenses<\/span><span class=\"f_BodyTextFirstIndent2\"> tab in <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">System Administration<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">S<\/span><span class=\"f_BodyText\">elect the license you want to remove and click the <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Remove<\/span><span class=\"f_BodyText\"> button.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
