hmLoadTopic({
hmKeywords:"",
hmTitle:"Hotspots",
hmDescription:"Hotspots are icons layered over the display of a Camera. Each Hotspot icon is linked to another Camera that provides an alternate view of the same area, or is the next Camera...",
hmPrevLink:"setting_same_parameters_for_multiple_cameras_(admi.html",
hmNextLink:"viewing_camera_stream_information.html",
hmParentLink:"setting_up_cameras_and_devices.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_cameras.html\">Device Management<\/a> &gt; <a href=\"setting_up_cameras_and_devices.html\">Setting Up Cameras and Devices<\/a>",
hmTitlePath:"Working with DW Spectrum > Device Management > Setting Up Cameras and Devices > Hotspots",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Hotspots<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Hotspots are icons layered over the display of a Camera. Each Hotspot icon is linked to another Camera that provides an alternate view of the same area, or is the next Camera to cover the path an object of interest may follow. Viewers can hover their mouse over a Hotspot to see a preview of the linked Camera, or click on the Hotspot to open the linked Camera on the current <a href=\"viewing_grid.html\" class=\"topiclink\">Viewing Grid<\/a> or in a new tab\/window. This provides an efficient method to follow objects of interest while they travel through doorways, down hallways, or in and out of the view of Cameras.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Hotspots can be freely positioned over the Camera display and remain in a fixed positions that is not affected by <a href=\"viewing_camera_stream_information.html\" class=\"topiclink\">Image Controls<\/a> or <a href=\"ptz-controls.html\" class=\"topiclink\">Pan, Tilt, and Zoom Controls<\/a>.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Managing Hotspots is limited to Administrators and Power Users, all Users who can View the Camera can toggle the Hotspot overlay on and off (see &quot;<a href=\"users-and-groups.html\" class=\"topiclink\">Users and Groups<\/a>&quot;).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Hotspots are disabled by default. They must be enabled for each Camera and after a new Camera has been added to the System (see &quot;<a href=\"setting_up_cameras_and_devices.html\" class=\"topiclink\">Setting Up Cameras and Devices<\/a>&quot;).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">A Camera can have one Hotspot configured for every other Camera in the System. Hotspots can be color coded and set with a directional indicator.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\">The Hotspot layer can be toggled per Camera display while the position and visibility of a Hotspot remains unchanged on all other Camera displays.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Hotspots are<\/span><span class=\"f_BodyText\"> functional in the Desktop Client and will not be visible in the Web Admin or Cloud Portal.<\/span><\/p><p class=\"p_BodyTextIndent\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">IMPORTANT:<\/span><span class=\"f_BodyTextIndent\"> Using PTZ controls to change the position of a Camera can affect the accuracy of the Hotspot as Hotspots do not track Camera movements.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To Add or Edit a Hotspot using the Desktop Client<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Open <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Camera Settings<\/span><span class=\"f_BodyTextIndent\"> by doing one of the follow:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Main Menu &gt; System Administration &gt; Camera List<\/span><span class=\"f_BodyTextIndent\"> and double click a Camera.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Open <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Camera Settings...<\/span><span class=\"f_BodyTextIndent\"> using the context menu on the Viewing Grid or a Camera name in the Resources Panel.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Switch to the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Hotspots<\/span><span class=\"f_BodyTextIndent\"> tab in the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Camera Settings<\/span><span class=\"f_BodyTextIndent\"> dialog.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Ensure Hotspots are enabled for the Camera by checking the toggle.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span><span class=\"f_BodyTextIndent\">Click the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Add<\/span><span class=\"f_BodyTextIndent\"> button and the next sequential Hotspot number is added to the center of the Camera display.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">5.<\/span><span class=\"f_BodyTextIndent\">Drag the Hotspot to any location on the Camera display; select a Hotspot color and rotate the optional pointer.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">6.<\/span><span class=\"f_BodyTextIndent\">In the list of Hotspots, click any Hotspot labeled <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Select Camera... <\/span><span class=\"f_BodyTextIndent\">to link a Camera to the Hotspot using the search and selection dialog.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">7.<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Apply<\/span><span class=\"f_BodyTextIndent\"> changes to remain in the Hotspot dialog or click <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">OK<\/span><span class=\"f_BodyTextIndent\"> to apply settings and exit the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Camera Settings <\/span><span class=\"f_BodyTextIndent\">dialog.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Note:<\/span><span class=\"f_BodyTextFirstIndent2\"> All created Hotspots that are not linked to a Camera will be removed when the <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Hotspot <\/span><span class=\"f_BodyTextFirstIndent2\">dialog is closed.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><img alt=\"Hotspot-Linking - 1\" style=\"margin:0;width:39.6875rem;height:35.3750rem;border:none\" src=\".\/images\/hmfile_hash_f7ded11f.png\"\/><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Using Hotspots<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">If not displayed, toggle the Hotspot layer using <\/span><span class=\"f_BodyText\"><a href=\"keyboard_shortcuts.html\" class=\"topiclink\">Keyboard Shortcut<\/a><\/span><span class=\"f_BodyTextIndent\"> (<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">&quot;H&quot;<\/span><span class=\"f_BodyTextIndent\">) or by Clicking the Hotspot icon in the display title bar.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Mouse-hover over a Hotspot to see a preview of the linked Camera.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Click on the Hotspot to open the linked Camera on the Viewing Grid.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span><span class=\"f_BodyTextIndent\">Right-click the Hotspot to open the Hotspot context menu.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Open Camera (on Viewing Grid).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Open Camera in a New Tab.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Open Camera in place (of the Camera displaying the Hotspot).<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To Delete a Hotspot using the Desktop Client<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Open Camera Settings by doing one of the follow:<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Main Menu &gt; System Administration &gt; Camera List<\/span><span class=\"f_BodyTextIndent\"> and double click a Camera.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Open <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Camera Settings...<\/span><span class=\"f_BodyTextIndent\"> using the context menu on the Viewing Grid or a Camera name in Resources Panel.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Change to the Hotspots tab in the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Camera Settings<\/span><span class=\"f_BodyTextIndent\"> dialog.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Remove Hotspots using the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Delete<\/span><span class=\"f_BodyTextIndent\"> icon in the list of Hotspots.<\/span><\/p><p class=\"p_BodyTextIndent\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">IMPORTANT:<\/span><span class=\"f_BodyTextIndent\"> Deleted Hotspots cannot be restored.<\/span><\/p>\n\r"
})
