hmLoadTopic({
hmKeywords:"",
hmTitle:"Objects Tab",
hmDescription:"Visibility of the Objects tab depends on the existence and type of analytics in the System and the user\'s permission level. When an analytics plugin is enabled, newly detected...",
hmPrevLink:"events_tab.html",
hmNextLink:"working_with_several_vms_windows.html",
hmParentLink:"notifications_panel.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"vms_user_interface_overview.html\">DW Spectrum Desktop User Interface<\/a> &gt; <a href=\"notifications_panel.html\">Notification Panel<\/a>",
hmTitlePath:"Working with DW Spectrum > DW Spectrum Desktop User Interface > Notification Panel > Objects Tab",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Objects Tab<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Visibility of the <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Objects<\/span><span class=\"f_BodyText\"> tab depends on the existence and type of analytics in the System and the user\'s permission level. When an analytics plugin is enabled, newly detected objects will appear as tiles if a <\/span><span class=\"f_BodyTextFirstIndent3\">C<\/span><span class=\"f_BodyText\">amera is open and being viewed (recording doesn\'t need to be enabled) or a Camera is recording. Previously detected objects stored in the archive will also appear as tiles. Detections not recorded to the archive will be lost after closing the Desktop Client.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Detected objects are outlined by bounding boxes that can be seen in the thumbnail that appears when hovering over the tile. The color used for bounding boxes can vary between object types and analytics plugins. Some analytics plugins allow the bounding box color for object types to be customized.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">The object filter can be used to filter for a specific object type, but by default it is on &quot;Any type&quot;. Depending on the analytics plugin being used, different selectable object types (e.g., car, human, bicycle, etc.) may be available to you.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">The Search field can search through object types and object text attributes (e.g., color, make, travel speed, etc.). See <\/span><span class=\"f_BodyTextIndent\">&quot;<\/span><span class=\"f_BodyTextFirstIndent2\"><a href=\"search.html\" class=\"topiclink\">Searching and Filtering in DW Spectrum<\/a><\/span><span class=\"f_BodyTextIndent\">&quot; and<\/span><span class=\"f_BodyText\"> &quot;<a href=\"plugins-and-analytics.html\" class=\"topiclink\">Analytics: Region of Interest (ROI)&quot;<\/a> for more details.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"Objects Tab 2\" style=\"margin:0;width:34.8125rem;height:40.0000rem;border:none\" src=\".\/images\/hmfile_hash_8d80dfeb.jpg\"\/><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\" style=\"background-color: #ffffff;\">&nbsp;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold; background-color: #ffffff;\">Note<\/span><span class=\"f_BodyTextIndent\" style=\"background-color: #ffffff;\">:<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;Fields from an&nbsp;<\/span><span class=\"f_BodyText\" style=\"font-style: italic; background-color: #ffffff;\">Analytics Event<\/span><span class=\"f_BodyText\" style=\"background-color: #ffffff;\">&nbsp;can be used to automatically fill in certain parameters when creating an HTTP Request is made (see &quot;<a href=\"perform_http_request.html\" class=\"topiclink\">Do HTTP(s) Request<\/a>&quot; for more information.)<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Default filter display is any time and the <\/span><span class=\"f_BodyTextFirstIndent3\">C<\/span><span class=\"f_BodyText\">ameras on <\/span><span class=\"f_BodyTextFirstIndent3\">L<\/span><span class=\"f_BodyText\">ayout. The area selector filter is always available and has the default state &quot;Select area&quot; when filtering is not applied. Click and drag over any device to create an area and enter filtering state &quot;In selected area&quot; for the selected camera. <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Detected objects are indicated with yellow segments in the Timeline. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"Timeline - Object\" style=\"margin:0;width:52.3125rem;height:7.6875rem;border:none\" src=\".\/images\/hmfile_hash_a4848dd0.png\"\/><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Advanced Object Search<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">For more granular control over the filtered object type, click <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Advanced <\/span><span class=\"f_BodyTextIndent\">to open up the Advanced Object Search dialog. This dialog displays objects from the Objects Tab in two or more columns (depending on window size) and will allow you to more easily switch between enabled plugins via the tabs at the top and configure other selected options such as object type in the menu on the left. To see the selected search result in the main window, click the play icon, and it will take you to that position in the archive.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"Advanced Object Search\" style=\"margin:0;width:56.7500rem;height:36.7500rem;border:none\" src=\".\/images\/hmfile_hash_3530582a.jpg\"\/><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: normal;\">When a result is selected and <\/span><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-style: italic; font-weight: normal;\">Preview<\/span><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: normal;\"> is clicked, a sidebar will open within the dialog, allowing you to preview that portion of the archive. Click <\/span><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-style: italic; font-weight: normal;\">Show on Layout<\/span><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif; font-weight: normal;\"> to go back to the main window and view that position in the archive.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"Advanced Object Search 2\" style=\"margin:0;width:56.7500rem;height:36.7500rem;border:none\" src=\".\/images\/hmfile_hash_a27e82a3.jpg\"\/><\/p>\n\r"
})
