hmLoadTopic({
hmKeywords:"",
hmTitle:"Preventing DW Spectrum from Changing Device Settings",
hmDescription:"When DW Spectrum discovers a camera, it captures the manufacturer\'s preset image quality settings and streaming configuration, then adjusts these settings to optimize the...",
hmPrevLink:"dual_streaming.html",
hmNextLink:"using-the-specific-onvif-profi.html",
hmParentLink:"configuring-expert-streaming-s.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_cameras.html\">Device Management<\/a> &gt; <a href=\"setting_up_cameras_and_devices.html\">Setting Up Cameras and Devices<\/a> &gt; <a href=\"working_around_device_issues_e.html\">Expert Device Settings<\/a> &gt; <a href=\"configuring-expert-streaming-s.html\">Configuring Expert Streaming Settings<\/a>",
hmTitlePath:"Working with DW Spectrum > Device Management > Setting Up Cameras and Devices > Expert Device Settings > Configuring Expert Streaming Settings > Preventing DW Spectrum from Changing Device Settings",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Preventing DW Spectrum from Changing Device Settings<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">When DW Spectrum discovers a camera, it captures the manufacturer\'s preset image quality settings and streaming configuration, then adjusts these settings to optimize the device for the DW Spectrum System. Manufacturer settings can also be adjusted manually, for example <\/span><span class=\"f_BodyTextIndent\">FPS, quality, and bitrate when a recording schedule is defined, or stream settings for a variety of reasons (see &quot;<a href=\"dual_streaming.html\" class=\"topiclink\">Dual Stream Processing<\/a>&quot;).<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">However, in some cases, it may be preferable to keep the native settings. For instance, you may want to maintain pre-existing FPS, bitrate, and resolution settings when connecting DW Spectrum to another VMS system. Or, on occasion the ONVIF implementation for a given camera diverges from standard ONVIF enough to make it preferable, or even necessary, to keep the manufacturer settings.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">It is possible to prevent the automatic optimization that DW Spectrum performs and use native stream and profile settings instead.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To <\/span><span class=\"f_BodyText\" style=\"text-decoration: underline;\">disable automatic optimization<\/span><span class=\"f_BodyText\" style=\"text-decoration: underline;\"> for a single c<\/span><span class=\"f_BodyText\" style=\"text-decoration: underline;\">amera<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Open <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Camera Settings<\/span><span class=\"f_BodyTextIndent\"> and go to the <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Expert<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> tab<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">Check <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Keep camera stream and profile settings<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Apply changes.<\/span><\/p><p class=\"p_BodyTextIndent\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">IMPORTANT:<\/span><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyText\">Enabling this flag means FPS and image quality settings in the recording schedule will be ignored.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Note:<\/span><span class=\"f_BodyTextIndent\"> This setting is not available for RTSP\/HTTP streams.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><a id=\"all_cameras\" class=\"hmanchor\"><\/a><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To disable automatic optimization for all cameras<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">It is possible to do this during the <a href=\"vms_quick_start.html\" class=\"topiclink\">Initial System Configuration<\/a>. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Later, it can be done as follows:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Desktop Client<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Open <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Main Menu<\/span><span class=\"f_BodyTextFirstIndent2\"> and go to <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">System Administration<\/span><span class=\"f_T_Interface_Elements\"> <\/span><span class=\"f_BodyTextFirstIndent2\">&gt; <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">General<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> tab.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Uncheck the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Allow System to optimize device settings<\/span><span class=\"f_BodyTextIndent\"> checkbox.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_T_Interface_Elements\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Apply changes.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Note: <\/span><span class=\"f_BodyTextFirstIndent2\">For each camera in your System, use the web page to set desired image<\/span><span class=\"f_BodyTextFirstIndent2\"> settings.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\"><a href=\"connecting_to_vms_thr.html\" class=\"topiclink\">Web Admin<\/a> \/ <a href=\"cloudname-portal-interface.html\" class=\"topiclink\">Cloud Portal<\/a><\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Open <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Settings <\/span><span class=\"f_BodyTextFirstIndent2\">&gt;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\"> System Administration <\/span><span class=\"f_BodyTextFirstIndent2\">&gt;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\"> General <\/span><span class=\"f_BodyTextFirstIndent2\">tab.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextFirstIndent2\">Unheck the <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Allow System to optimize device settings<\/span><span class=\"f_BodyTextFirstIndent2\"> checkbox.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextFirstIndent2\">Apply changes.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><span class=\"f_BodyTextFirstIndent2\">&nbsp;<\/span><\/p>\n\r"
})
