hmLoadTopic({
hmKeywords:"",
hmTitle:"PTZ – Pan, Tilt, and Zoom controls",
hmDescription:"DW Spectrum will present a PTZ Guide the first time PTZ controls are activated on a System, unless the Alternate UI for PTZ has been enabled. Once viewed, the PTZ Guide will...",
hmPrevLink:"working_with_fish-eye_cameras.html",
hmNextLink:"saving_and_restoring_ptz_posit.html",
hmParentLink:"viewing_camera_stream_information.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_cameras.html\">Device Management<\/a> &gt; <a href=\"setting_up_cameras_and_devices.html\">Setting Up Cameras and Devices<\/a> &gt; <a href=\"viewing_camera_stream_information.html\">Image Controls<\/a>",
hmTitlePath:"Working with DW Spectrum > Device Management > Setting Up Cameras and Devices > Image Controls > Pan, Tilt, and Zoom Controls",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">PTZ – Pan, Tilt, and Zoom controls<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">DW Spectrum will present a PTZ Guide the first time PTZ controls are activated on a System, unless the Alternate UI for PTZ has been enabled. Once viewed, the PTZ Guide will only be shown after navigating to <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Main Menu &gt; Local Settings &gt; Advanced <\/span><span class=\"f_BodyText\">and clicking on the &quot;<\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Reset All Warnings<\/span><span class=\"f_BodyText\">&quot; button.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">To the extent supported by a particular ONVIF camera, PTZ<\/span><span class=\"f_BodyText\"> controls <\/span><span class=\"f_BodyText\">(Pan, Tilt, and Zoom) are available when the Camera is in Live mode. <\/span><span class=\"f_BodyText\">PTZ controls are also available on archived footage for fish-eye cameras<\/span><span class=\"f_BodyText\"> that have dewarping enabled (see &quot;<a href=\"working_with_fish-eye_cameras.html\" class=\"topiclink\">Dewarping Controls<\/a>&quot;).<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyTextIndent\">Cameras that support <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">ONVIF Absolute Move <\/span><span class=\"f_BodyTextIndent\">have the following features:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"saving_and_restoring_ptz_posit.html\" class=\"topiclink\">Saving and Restoring PTZ Positions<\/a><\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: -0.4375rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\"><a href=\"setting_up_ptz_tours.html\" class=\"topiclink\">Setting Up PTZ Tours<\/a><\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: -0.4375rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">Relative PTZ<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">When PTZ requirements are met and enabled, the PTZ icon <img alt=\"ptz_hovered\" style=\"margin:0;width:1.1250rem;height:1.1250rem;border:none\" src=\".\/images\/ptz_hovered.png\"\/> will display on the corresponding camera item. See <a href=\"adjusting-ptz-speed.html\" class=\"topiclink\">Adjusting PTZ Speed<\/a> and <a href=\"selecting-ptz-presets.html\" class=\"topiclink\">Selecting PTZ Presets<\/a> for more configuration options.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Manufacturer &quot;Native&quot; PTZ Settings<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Native PTZ camera presets – those provided in-camera – for a specific camera can maintained by checking <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Use camera native presets<\/span><span class=\"f_BodyTextIndent\"> in <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Camera Settings<\/span><span class=\"f_BodyTextIndent\"> &gt; <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Expert<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">. To <\/span><span class=\"f_BodyTextIndent\">ignore manufacturer settings in favor of DW Spectrum settings, check <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Use system presets<\/span><span class=\"f_BodyTextIndent\"> instead<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Default UI for PTZ controls<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Depending on the camera model, one of the following modes is available when you click on the PTZ icon <img alt=\"ptz_hovered\" style=\"margin:0;width:1.1250rem;height:1.1250rem;border:none\" src=\".\/images\/ptz_hovered.png\"\/>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Simple<\/span><span class=\"f_BodyTextIndent\"> (<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Zoom <\/span><span class=\"f_BodyTextIndent\">only<\/span><span class=\"f_BodyTextIndent\">) – Use the mouse wheel or +\/- keys to zoom.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><img alt=\"Setting up PTZ - 4\" style=\"margin:0;width:40.0000rem;height:22.6875rem;border:none\" src=\".\/images\/hmfile_hash_ee373502.jpg\"\/><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Regular<\/span><span class=\"f_BodyTextIndent\"> (<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Zoom <\/span><span class=\"f_BodyTextIndent\">and <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Point<\/span><span class=\"f_BodyTextIndent\">) – In addition to the zoom functionality from <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Simple<\/span><span class=\"f_BodyTextIndent\"> mode, press the arrow keys or drag over any part of the video to point (pan\/tilt) the camera.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><span class=\"f_ImageCaption\">.<img alt=\"Setting up PTZ - 5\" style=\"margin:0;width:40.0000rem;height:22.6875rem;border:none\" src=\".\/images\/hmfile_hash_6dde868a.jpg\"\/><\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Advanced PTZ <\/span><span class=\"f_BodyTextIndent\">(<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Zoom<\/span><span class=\"f_BodyTextIndent\">, <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Point <\/span><span class=\"f_BodyTextIndent\">and<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> additional features<\/span><span class=\"f_BodyTextIndent\">) <\/span><span class=\"f_BodyTextIndent\">– In addition to the zoom and point functionality from <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Regular<\/span><span class=\"f_BodyTextIndent\"> mode, <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Extended<\/span><span class=\"f_BodyTextIndent\"> mode requires a custom product integration and ONVIF Absolute Move support from the camera. <\/span><span class=\"f_BodyTextIndent\">Extended<\/span><span class=\"f_BodyTextIndent\"> mode allows the following additional controls:<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.3750rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Shift + Click<\/span><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextFirstIndent2\">anywhere in the field of view to re-center at that position.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Shift + Click-and-drag<\/span><span class=\"f_BodyTextIndent\"> and draw a zoom rectangle that can be positioned until the mouse button is released.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.6250rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Shift + Double-click<\/span><span class=\"f_BodyTextIndent\"> to zoom out all the way.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"Setting up PTZ - 6\" style=\"margin:0;width:40.0000rem;height:22.6875rem;border:none\" src=\".\/images\/hmfile_hash_f403890c.jpg\"\/><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><a id=\"alternativeptzcontrols\" class=\"hmanchor\"><\/a><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Alternate PTZ Controls<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Enable the alternative UI for PTZ controls by selecting the checkbox next to &quot;<\/span><span class=\"f_BodyTextIndent\"><a href=\"customizing_product_name.html#showaimoverlayforptzcameras\" class=\"topiclink\">Show aim overlay for PTZ cameras<\/a>&quot;.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: The PTZ Guide will not be shown if the Alternate UI for PTZ is enabled.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Depending on the camera model, one of the following modes is available when you click on the PTZ icon <img alt=\"ptz_hovered\" style=\"margin:0;width:1.1250rem;height:1.1250rem;border:none\" src=\".\/images\/ptz_hovered.png\"\/>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Simple<\/span><span class=\"f_BodyTextIndent\"> (<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Zoom <\/span><span class=\"f_BodyTextIndent\">only<\/span><span class=\"f_BodyTextIndent\">) – As shown in the image below, only the <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">+<\/span><span class=\"f_BodyText\"> and <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">-<\/span><span class=\"f_BodyText\"> buttons are available to zoom in and out. <\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><img alt=\"Setting up PTZ - 1\" style=\"margin:0;width:40.0625rem;height:22.6875rem;border:none\" src=\".\/images\/hmfile_hash_7d43673e.jpg\"\/><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Regular<\/span><span class=\"f_BodyTextIndent\"> (<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Zoom <\/span><span class=\"f_BodyTextIndent\">and <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Point<\/span><span class=\"f_BodyTextIndent\">) – U<\/span><span class=\"f_BodyText\">se the <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">+<\/span><span class=\"f_BodyText\"> and <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">- <\/span><span class=\"f_BodyText\">buttons to zoom in and out. When there is a center circle as shown below, you can use it to click-and-drag the center of the image to the desired position.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><img alt=\"Setting up PTZ - 2\" style=\"margin:0;width:40.0625rem;height:22.6875rem;border:none\" src=\".\/images\/hmfile_hash_b21d5573.jpg\"\/><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Extended<\/span><span class=\"f_BodyTextIndent\"> (<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Zoom<\/span><span class=\"f_BodyTextIndent\">, <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Point <\/span><span class=\"f_BodyTextIndent\">and<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> additional features<\/span><span class=\"f_BodyTextIndent\">)<\/span><span class=\"f_BodyTextIndent\"> – Requires a custom product integration and ONVIF <\/span><span class=\"f_BodyTextIndent\">Absolute Move<\/span><span class=\"f_BodyTextIndent\"> support<\/span><span class=\"f_BodyTextIndent\"> from the camera. Allows zooming, repositioning, and the following additional controls:<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><img alt=\"Setting up PTZ - 3\" style=\"margin:0;width:40.0000rem;height:22.6250rem;border:none\" src=\".\/images\/hmfile_hash_db3b9ec7.jpg\"\/><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: -0.4375rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Click<\/span><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextFirstIndent2\">anywhere in the field of view to re-center at that position.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Click-and-drag<\/span><span class=\"f_BodyTextIndent\"> and draw a zoom rectangle that can be positioned until the mouse button is released.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Double-click<\/span><span class=\"f_BodyTextIndent\"> to zoom out all the way.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Once a PTZ position is set, press <img alt=\"ptz_hovered\" style=\"margin:0;width:1.1250rem;height:1.1250rem;border:none\" src=\".\/images\/ptz_hovered.png\"\/> again to hide PTZ controls.<\/span><\/p>\n\r"
})
