hmLoadTopic({
hmKeywords:"",
hmTitle:"Searching and Filtering",
hmDescription:"DW Spectrum enable users to search and filter data in various forms (Audit Trail of User Actions, Event Log, Device List, Users etc). The common UI element is a search box....",
hmPrevLink:"showing_and_hiding_side_panels.html",
hmNextLink:"navigation_panel.html",
hmParentLink:"vms_user_interface_overview.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"vms_user_interface_overview.html\">DW Spectrum Desktop User Interface<\/a>",
hmTitlePath:"Working with DW Spectrum > DW Spectrum Desktop User Interface > Searching and Filtering",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Searching and Filtering<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">DW Spectrum enable users to search and filter data in various forms (<\/span><span class=\"f_BodyTextIndent\"><a href=\"viewing_users_actions_log_audi.html\" class=\"topiclink\">Audit Trail of User Actions<\/a><\/span><span class=\"f_BodyText\">, Event Log, Device List, Users etc). The common UI element is a search box. Type any characters there to activate a search. Search results appear in the form immediately as characters are entered. This is because Camera ID strings are so long and contain so many characters they could flood search results without this limitation.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">The search functionality in the Resource Panel is a little different than everywhere else in DW Spectrum. The Resource Panel display can be <\/span><span class=\"f_BodyText\">filtered in two ways, by type and by text, and these two filters can be applied separately or together. By using this function, the following items can be searched for: Servers, Devices (I\/O modules, cameras, etc.), Layouts, Showreels, Video Walls, Web Pages, Users, Local Files, and Groups. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note: <\/span><span class=\"f_BodyText\">The display of server and device IP addresses will change according to the setting of the <\/span><span class=\"f_BodyText\" style=\"font-style: italic;\">Show additional info in tree<\/span><span class=\"f_BodyText\"> option, see the <a href=\"customizing_product_name.html\" class=\"topiclink\">Customizing the Look and Feel<\/a> section for more information.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyTextIndent\" style=\"text-decoration: underline;\">Filtering by Resource Type<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Only one resource type can be selected at a time. The type filter can be applied by clicking on the magnifying glass (<img alt=\"search_resources\" style=\"margin:0;width:1.1875rem;height:1.0000rem;border:none\" src=\".\/images\/search_resources.png\"\/>) in the Search field to open a drop-down menu. When a type filter is applied, the tree structure changes – all elements become grouped by type, and are displayed without nested elements of a different type (for example, cameras under layouts under users). <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">You can select a group from the search results <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">(Shift + Click)<\/span><span class=\"f_BodyTextIndent\"> or select multiple items sequentially <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">(Ctrl + Click)<\/span><span class=\"f_BodyTextIndent\">. You can add items from the search results to the existing layout <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">(Enter)<\/span><span class=\"f_BodyTextIndent\"> or open all selected items into a new layout <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">(Right-click &gt; Open in New Tab)<\/span><span class=\"f_BodyTextIndent\">. Note that the cursor must be in the search field for these add-to-layout functions to be available.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Filtering by Text<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Any text entered in the Search field filters the existing resource display. Multiple keywords are treated as a Boolean &quot;AND&quot;. For example entering <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">abc<\/span><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">def<\/span><span class=\"f_BodyTextIndent\"> returns only resources which have <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">abc<\/span><span class=\"f_BodyTextIndent\"> and <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">def<\/span><span class=\"f_BodyTextIndent\">. If the filter returns a large number of results, only the first 64 results will be displayed. Camera ID fields are only searched if a query is 4 symbols or longer.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Search Syntax <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">Search syntax in DW Spectrum search fields is generally the same across all DW Spectrum resources, but additional search features are available in a few places. <\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">The standard search syntax includes the following:<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">Single word search (not case-sensitive)<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.0625rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Two word search (not case-sensitive and the search terms’ order does not matter)<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Search Fields That Use the Standard Search Syntax<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"using_media_servers_web_interf.html\" class=\"topiclink\">Server Web Admin<\/a><\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"vms_user_interface_overview.html\" class=\"topiclink\">Desktop Client<\/a><\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent2\">Resource Panel<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent2\">Event Rules (Indexed field: Source)<\/span><br \/>\n\r<img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: <\/span><span class=\"f_BodyTextFirstIndent2\">Events with more than one camera set will show up in your search results if one of the cameras match the search term, but the exact camera name will not be visible until you click on the list of cameras for that event.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent2\">Event Log (Indexed field: Description) <\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent2\">Cameras list (Indexed fields: Name, Vendor, Model, Firmware, IP, and MAC address)<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent2\">Audit Trail (Indexed fields: Camera name, User, IP, Activity, Description, Session ends)<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"cloudname-portal-interface.html\" class=\"topiclink\">Cloud Portal<\/a><\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">Search Fields That Do Not Use the Standard Search Syntax<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">The following places in the Desktop Client have an exception or additional search features.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">User Manual<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent3\">Two word search terms will provide results for both search terms together and separately.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 3.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">An asterisk (*) can be used in any position to any number of symbols.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 3.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">A question mark (?) can be used to substitute a single character.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 3.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">A hyphen (-) can be used in front of the second search term to search for lines that contain the first term but not the second term.<\/span><\/p><p class=\"p_BodyText\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 2.9375rem; margin-left: 0;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\"><a href=\"users_management.html\" class=\"topiclink\">User Management<\/a><\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent3\">Unlike two-word searches across our other resources, only results matching the exact order of search terms will show up.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 3.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">A question mark can be used to substitute a single character.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 3.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextIndent\">An asterisk can be used in any position to any number of symbols.<\/span><\/p><p class=\"p_BodyText\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 2.9375rem; margin-left: 0;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\"><a href=\"search_using_bookmarks.html\" class=\"topiclink\">Bookmark Log<\/a> <\/span><span class=\"f_BodyTextIndent\">–<\/span><span class=\"f_BodyText\"> (Indexed fields: Name, Description, and Tags)<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent3\">Quotations can be used to find results with the search terms in the order specified.<\/span><\/p><p class=\"p_BodyText\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 2.9375rem; margin-left: 0;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyText\"><a href=\"notifications_panel.html\" class=\"topiclink\">Notification Panel<\/a>, <a href=\"bookmarks_tab.html\" class=\"topiclink\">Bookmarks tab<\/a> (Indexed fields: Name, Description, and Tags) and <a href=\"objects_tab.html\" class=\"topiclink\">Objects tab<\/a> (Indexed fields: Object type and Object text attributes)<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: \'Courier New\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">o<\/span><span class=\"f_BodyTextFirstIndent3\">Quotations can be used to find results with the search terms in the order specified.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><span class=\"f_BodyTextFirstIndent2\">&nbsp;<\/span><\/p>\n\r"
})
