hmLoadTopic({
hmKeywords:"",
hmTitle:"Setting Up Cameras and Devices",
hmDescription:"Cameras and Devices contain internal settings specified by the manufacture and System settings that DW Spectrum applies outside of the Device. An example is Camera Resolution...",
hmPrevLink:"deleting_a_camera_(admin_only).html",
hmNextLink:"obtaining_cameras_ip_and_mac.html",
hmParentLink:"configuring_cameras.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_cameras.html\">Device Management<\/a>",
hmTitlePath:"Working with DW Spectrum > Device Management > Setting Up Cameras and Devices",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Setting Up Cameras and Devices<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Cameras and Devices contain internal settings specified by the manufacture and System settings that DW Spectrum applies outside of the Device. An example is Camera Resolution being set and defined within the Camera while Camera Hotspots are defined and contained within the Desktop Client. The devices settings and options available through the System will vary depending on device model, firmware installed, and compliance with industry standards.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Users must be a member of a group having <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Edit Device<\/span><span class=\"f_BodyText\"> permissions or have been granted permission to <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Edit a Device<\/span><span class=\"f_BodyText\"> to perform the tasks outlined in this topics (<\/span><span class=\"f_BodyText\">see &quot;<a href=\"users-and-groups.html\" class=\"topiclink\">Users and Groups<\/a>&quot;).<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyText\">: It<\/span><span class=\"f_BodyTextFirstIndent2\"> is possible to configure image controls, audio, recording schedule, authentication credentials, etc. – for several devices simultaneously. See “<a href=\"setting_same_parameters_for_multiple_cameras_(admi.html\" class=\"topiclink\">Applying Parameters to Multiple Devices<\/a>”.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold; text-decoration: underline;\">Device Set Up<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"obtaining_cameras_ip_and_mac.html\" class=\"topiclink\">Obtaining Basic Device Information<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"configuring_camera_authentication_(admin_only).html\" class=\"topiclink\">Device Authentication<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"renaming_a_camera.html\" class=\"topiclink\">Renaming a Device<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"setting_camera_orientation.html\" class=\"topiclink\">Setting Camera Orientation<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"setting_camera_aspect_ratio.html\" class=\"topiclink\">Setting Camera Aspect Ratio<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"hot-spot-and-camera-linking.html\" class=\"topiclink\">Hot Spot and Camera Linking<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"viewing_events_log.html\" class=\"topiclink\">Events Log<\/a><\/span><span class=\"f_BodyText\">.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextFirstIndent2\"><a href=\"configuring_event_rules.html\" class=\"topiclink\">Event Rules List<\/a><\/span><span class=\"f_BodyText\">.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold; text-decoration: underline;\">Image Control<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"color_correction.html\" class=\"topiclink\">Image Enhancement<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"ptz-controls.html\" class=\"topiclink\">Pan, Tilt, and Zoom Controls<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"working_with_fish-eye_cameras.html\" class=\"topiclink\">Dewarping Controls<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"saving_and_restoring_ptz_posit.html\" class=\"topiclink\">Saving and Restoring PTZ Positions<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"setting_up_ptz_tours.html\" class=\"topiclink\">Setting Up PTZ Tours<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\" style=\"font-weight: bold; text-decoration: underline;\">Configuration Settings<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"configuring_audio_for_the_camera_(admin_only).html\" class=\"topiclink\">Configuring Audio on a Device<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"virtual_camera.html\" class=\"topiclink\">Setting Up a Virtual Camera<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"setting_up_i_o_modules.html\" class=\"topiclink\">Setting Up an I\/O Module<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"setting_up_analog_cameras.html\" class=\"topiclink\">Setting Up an Analog Camera<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"setting_up_motion_mask_and_motion_sensitivity_(adm.html\" class=\"topiclink\">Setting Up Motion Detection<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"editing_recording_schedule.html\" class=\"topiclink\">Setting a Recording Schedule<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"recording_modes.html\" class=\"topiclink\">Recording Modes<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"margin: 0.1250rem 0 0.1250rem 1.6875rem;\"><span class=\"f_BodyTextIndent\"><a href=\"configuring-maxi-and-min-archive-storage.html\" class=\"topiclink\">Configuring Minimum and Maximum Archive Storage<\/a>.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
