hmLoadTopic({
hmKeywords:"",
hmTitle:"Soft Trigger",
hmDescription:"This event type adds a button to one or more devices in layout. When a User clicks on a soft trigger button, the associated action is triggered. The event can be instant...",
hmPrevLink:"media_server_started.html",
hmNextLink:"storage_failure.html",
hmParentLink:"events_available_in_vms.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_events_and_actions.html\">Event Rules<\/a> &gt; <a href=\"events_available_in_vms.html\">Tracked Events<\/a>",
hmTitlePath:"Working with DW Spectrum > Event Rules > Tracked Events > Soft Trigger",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Soft Trigger<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">This event type adds a button to one or more devices in layout. When a User clicks on a soft trigger button, the associated action is triggered. The event can be instant (triggers when the button is clicked), or continuous (triggers as long as the button is held). Soft trigger buttons appear as a circular overlay in the lower-right region of an item, and will display the contents of the <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">Name<\/span><span class=\"f_BodyText\"> field when the mouse cursor is hovered over it.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"Soft Triggers - 4\" style=\"margin:0;width:31.1875rem;height:17.6875rem;border:none\" src=\".\/images\/hmfile_hash_d260fcdf.jpg\"\/><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">For example, you can create soft trigger button to start and stop a Bookmark recording when an operator sees suspicious activity. Or, it could be a panic button that starts a siren when an emergency situation is detected.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">In addition to making it possible for a User to initiate an action from layout, a soft trigger that has a &quot;<a href=\"perform_http_request.html\" class=\"topiclink\">Perform HTTP Request<\/a>&quot; action makes it possible to integrate third-party systems and devices, and to bundle multiple actions within an event. For example, you can create a soft trigger with an HTTP request to a 3rd party device that initiates one or more of the actions the device is capable of, such as &quot;if temperature that exceeds 110<\/span><span class=\"f_BodyText\">°<\/span><span class=\"f_BodyText\">F is detected, close door.&quot; <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Basic Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">At<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyTextFirstIndent2\">– Click in this field to select the d<\/span><span class=\"f_BodyTextIndent\">evice(s) <\/span><span class=\"f_BodyTextIndent\">that will have the soft trigger button.<\/span><span class=\"f_BodyTextFirstIndent2\"> If &lt;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Any Device<\/span><span class=\"f_BodyTextFirstIndent2\">&gt; is selected then the button will be placed on offline <\/span><span class=\"f_BodyTextFirstIndent2\">devices<\/span><span class=\"f_BodyTextFirstIndent2\"> as well.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Available to <\/span><span class=\"f_BodyTextFirstIndent2\">– C<\/span><span class=\"f_BodyTextIndent\">lick in this field to select the Users or User Groups that are allowed to use the trigger.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">IMPORTANT: <\/span><span class=\"f_BodyTextFirstIndent2\">To be able to trigger an event on a device, the User or User role must have input permission on the device. If they do not, the following warning appears:<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><img alt=\"Soft Triggers - 2\" style=\"margin:0;width:25.3125rem;height:30.1250rem;border:none\" src=\".\/images\/hmfile_hash_44523cc8.png\"\/><span class=\"f_BodyTextFirstIndent2\">.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Name<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyTextFirstIndent2\">– Enter a brief description of the event that will triggered. Contents of this field are displayed on layout when the mouse cursor hovers over the button.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Icon<\/span><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextFirstIndent2\">– Select from the menu of available icons.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Advanced Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"setting_up_schedule_for_tracki.html\" class=\"topiclink\">Event Scheduling<\/a><\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Why Event may work incorrectly<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Action<\/span><span class=\"f_BodyTextIndent\"> is not configured properly. <\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"global_notifications.html\" class=\"topiclink\">Global notification<\/a> for this event is disabled.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
