hmLoadTopic({
hmKeywords:"",
hmTitle:"Obtaining and Installing an Authorized Certificate",
hmDescription:"By default, the DW Spectrum server is installed with a generated self-signed certificate which has the lowest security level. If you use this certificate and use a web browser...",
hmPrevLink:"configuring-secure-connections.html",
hmNextLink:"to-connect-to-cameras-over-onl.html",
hmParentLink:"configuring-secure-connections.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring-secure-connections.html\">Configuring Secure Connections<\/a>",
hmTitlePath:"Working with DW Spectrum > Configuring Secure Connections > Obtaining and Installing an Authorized Certificate",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Obtaining and Installing an Authorized Certificate<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">By default, the <\/span><span class=\"f_BodyText\">DW Spectrum <\/span><span class=\"f_BodyText\">server is installed with a generated self-signed certificate which has the lowest security level. If you use this certificate and use a web browser to connect to the Server through HTTPS, a warning message will appear stating that the connection to the site is not secure (see &quot;<a href=\"certificate-validation.html\" class=\"topiclink\">Server Certificate Validation<\/a>&quot;). This means that using the self-signed certificate is not recommended, even though a secure connection <\/span><span class=\"f_BodyText\">is used. It is therefore recommended to obtain a certificate from an authorized certificate provider and install it on the Server that is used for public access (from outside of the local network).<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To Obtain and Install an Authorized Certificate<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Obtain a certificate from any certificate provider (for instance, see the list of top ones here: <a href=\"https:\/\/www.techradar.com\/news\/best-ssl-certificate-provider\" target=\"_blank\" class=\"weblink\">https:\/\/www.techradar.com\/news\/best-ssl-certificate-provider<\/a>).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Create a file <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">cert.pem<\/span><span class=\"f_BodyTextIndent\"> with the Private Key and Entire Trust Chain (see the instructions on the certificate provider\'s web site).<\/span><\/p><p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 2.1250rem; margin-left: 0;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Place the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">cert.pem<\/span><span class=\"f_BodyTextIndent\"> file in the following folder:<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_T_Value\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\">Windows: <\/span><span class=\"f_T_Value\">C:\\Windows\\System32\\config\\systemprofile\\AppData\\Local\\Digital Watchdog\\Digital Watchdog Media Server\\ssl<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 2.0000rem; margin-left: 2.1250rem;\"><span class=\"f_T_Value\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">Linux: \/opt\/digitalwatchdog\/mediaserver\/var\/ssl<\/span><\/p><p class=\"p_Normal\" style=\"text-indent: 0; padding-left: 2.1250rem; margin-left: 0;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">4.<\/span><span style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\">Restart the server.<\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">For Servers within the local network it is recommended to install the Self-Signed SSL certificate into the Trusted Root Certificate Authorities Store (<a href=\"https:\/\/specopssoft.com\/support-docs\/specops-password-reset\/reference-material\/installing-the-self-signed-ssl-certificate-into-the-trusted-root-certificate-authorities-store\/\" target=\"_blank\" class=\"weblink\">https:\/\/specopssoft.com\/support-docs\/specops-password-reset\/reference-material\/installing-the-self-signed-ssl-certificate-into-the-trusted-root-certificate-authorities-store\/<\/a>). <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To View A Server\'s Security Certificate<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextIndent\">Right-click on a Server and select <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Server Settings<\/span><span class=\"f_BodyTextIndent\">.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Find the <\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Certificate<\/span><span class=\"f_BodyTextIndent\"> field and click on the <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">DW Spectrum<\/span><span class=\"f_BodyTextIndent\"> hyperlink.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">A dialog displaying the following information about the SSL certificate will appear:<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">Certificate signer (e.g. Self or Trusted CA)<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">Fingerprints<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">Certificate data<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\">Expiration date<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To Set Server Certificate Validation<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">This option prevents the Desktop Client from connecting to untrusted servers (the ones not having a valid certificate). This is set individually for each instance of the Desktop Client.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 1.2500rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">1.<\/span><span class=\"f_BodyTextFirstIndent2\">Open <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Main Menu<\/span><span class=\"f_BodyTextFirstIndent2\"> &gt; <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Local Settings<\/span><span class=\"f_BodyTextFirstIndent2\"> &gt; <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Advanced <\/span><span class=\"f_BodyTextFirstIndent2\">tab.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">2.<\/span><span class=\"f_BodyTextIndent\">Click on the<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> Server certificate validation<\/span><span class=\"f_BodyTextIndent\"> drop-down menu and choose one of the following options:<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent3\" style=\"font-style: italic;\">Disabled<\/span><span class=\"f_BodyTextFirstIndent3\"> – Any certificate is allowed. No warnings are displayed.<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"page-break-inside: avoid;\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\"> <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">IMPORTANT: <\/span><span class=\"f_BodyTextFirstIndent3\">This may lead to privacy issues.<\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Recommended <\/span><span class=\"f_BodyTextFirstIndent2\">– Your confirmation will be requested to pin self-signed certificates.<\/span><\/p><p class=\"p_BodyTextFirstIndent3\" style=\"text-indent: 0; page-break-inside: avoid; padding-left: 0.8125rem; margin-left: 3.3125rem;\"><span class=\"f_BodyTextFirstIndent3\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-style: italic;\">Strict <\/span><span class=\"f_BodyTextFirstIndent2\">– Only trusted certificates are allowed (i.e. no self-signed certificates).<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 2.5000rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextFirstIndent2\" style=\"display:inline-block;width:1.2500rem;margin-left:-1.2500rem\">3.<\/span><span class=\"f_BodyTextIndent\">Apply changes.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"text-decoration: underline;\">To Get Notifed about Certificate Validation Issues<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">If a certificate is invalid, the &quot;<a href=\"server-certificate-error.html\" class=\"topiclink\">Server Certificate Error<\/a>&quot; event is triggered.<\/span><\/p>\n\r"
})
