hmLoadTopic({
hmKeywords:"",
hmTitle:"Device Output",
hmDescription:"Generates output on a device when an event occurs, starts, or stops.",
hmPrevLink:"create_bookmark.html",
hmNextLink:"start_recording_on_camera.html",
hmParentLink:"actions_that_vms_can_.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_events_and_actions.html\">Event Rules<\/a> &gt; <a href=\"actions_that_vms_can_.html\">Available Actions<\/a>",
hmTitlePath:"Working with DW Spectrum > Event Rules > Available Actions > Device Output",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Device Output<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Generates output on a device when an event <\/span><span class=\"f_BodyTextIndent\">occurs, starts, or stops.<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\"><img alt=\"!\" style=\"margin:0;width:1.0000rem;height:1.0000rem;border:none\" src=\".\/images\/!.png\"\/><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">IMPORTANT:<\/span><span class=\"f_BodyTextFirstIndent2\"> Output must <\/span><span class=\"f_BodyTextFirstIndent2\">be supported <\/span><span class=\"f_BodyTextFirstIndent2\">on the selected devices. <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Basic Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">At<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyTextFirstIndent2\">– D<\/span><span class=\"f_BodyTextIndent\">evice(s)<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\"> <\/span><span class=\"f_BodyTextIndent\">on which<\/span><span class=\"f_BodyTextIndent\"> output will be triggered. To specify devices see <a href=\"selection_lists_in_event_rules.html\" class=\"topiclink\">Selection Lists in Event Rules<\/a>. At least one device must be selected.<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_T_Interface_Elements\">Also trigger on source camera<\/span><span class=\"f_BodyTextIndent\"> – Check<\/span><span class=\"f_BodyTextIndent\"> <\/span><span class=\"f_BodyTextIndent\">to <\/span><span class=\"f_BodyTextIndent\">to send the output signal to the camera selected in the event.<\/span><\/p><p class=\"p_BodyTextIndent\"><img alt=\"note\" style=\"margin:0;width:1.1875rem;height:1.1875rem;border:none\" src=\".\/images\/note.png\"\/><span class=\"f_ImageCaption\" style=\"font-size: 1.10rem; font-family: Calibri,Vectora,\'Droid Sans\',\'Open Sans\',Frutiger,sans-serif;\"> <\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Note<\/span><span class=\"f_BodyTextFirstIndent2\">:<\/span><span class=\"f_BodyTextFirstIndent2\"> A warning notification will open i<\/span><span class=\"f_BodyTextFirstIndent2\">f one or more of the selected devices does not have an output relay. These devices will be highlighted in red.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Advanced Parameters<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-style: italic;\">Output ID<\/span><span class=\"f_BodyTextIndent\"> – The I\/O Module port ID to route signal to (see &quot;<a href=\"setting_up_i_o_modules.html\" class=\"topiclink\">Setting Up I\/O Modules<\/a>&quot;).<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">May be caused by<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Any Event<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"motion_on_camera.html\" class=\"topiclink\">Motion on Camera<\/a>, <a href=\"generic_event.html\" class=\"topiclink\">Generic Event<\/a>, <a href=\"analytics_event.html\" class=\"topiclink\">Analytics Event<\/a>, <a href=\"soft_triggers.html\" class=\"topiclink\">Soft Trigger<\/a>, and <a href=\"input_signal_on_camera.html\" class=\"topiclink\">Input Signal on Device<\/a> – synchronous output. Output stops when motion or input stops.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\" style=\"font-weight: bold;\">Why Action may work incorrectly<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Output is not supported on some devices. <\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Event is not configured properly. <\/span><\/p><p class=\"p_BodyTextIndent\"><span class=\"f_BodyTextIndent\">&nbsp;<\/span><\/p>\n\r"
})
