hmLoadTopic({
hmKeywords:"",
hmTitle:"Configuring ONVIF Profiles",
hmDescription:"DW Spectrum automatically discovers devices and configures the optimal streaming parameters to fetch data from devices. For this purpose, the ONVIF protocol is used.",
hmPrevLink:"preventing_vms_from_c.html",
hmNextLink:"setting_up_camera_transport_pr.html",
hmParentLink:"configuring-expert-streaming-s.html",
hmBreadCrumbs:"<a href=\"index.html\">Working with DW Spectrum<\/a> &gt; <a href=\"configuring_cameras.html\">Device Management<\/a> &gt; <a href=\"setting_up_cameras_and_devices.html\">Setting Up Cameras and Devices<\/a> &gt; <a href=\"working_around_device_issues_e.html\">Expert Device Settings<\/a> &gt; <a href=\"configuring-expert-streaming-s.html\">Configuring Expert Streaming Settings<\/a>",
hmTitlePath:"Working with DW Spectrum > Device Management > Setting Up Cameras and Devices > Expert Device Settings > Configuring Expert Streaming Settings > Configuring ONVIF Profiles",
hmHeader:"<h1 class=\"p_Heading1\"><span class=\"f_Heading1\">Configuring ONVIF Profiles<\/span><\/h1>\n\r",
hmBody:"<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">DW Spectrum automatically discovers devices and configures the optimal streaming parameters to fetch data from devices. For this purpose, the ONVIF protocol is used.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">The communication is configured according to the <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">ONVIF Network Interface specification<\/span><span class=\"f_BodyText\">.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">DW Spectrum supports <\/span><span class=\"f_BodyText\">different ONVIF Network Interface specifications:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Media<\/span><span class=\"f_BodyTextIndent\"> – the older one (is supported by all ONVIF devices)<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Media2<\/span><span class=\"f_BodyTextIndent\"> – the newer one.<\/span><span class=\"f_BodyText\"> <\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">If the device reports that <\/span><span class=\"f_BodyTextIndent\">Media2 is supported, <\/span><span class=\"f_BodyText\">DW Spectrum will try to use it.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">The audio and video communication is configured through <\/span><span class=\"f_BodyText\" style=\"font-weight: bold;\">stream profiles.<\/span><span class=\"f_BodyText\"> <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">A profile describes the set of parameters related to audio\/video transport from a device to the <\/span><span class=\"f_BodyText\">DW Spectrum Server<\/span><span class=\"f_BodyText\">:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">A\/V Codec<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Bitrate<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Resolution<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Additional parameters.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Usually, cameras provide 2 independent stream profiles:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Primary stream (Hi-Res)<\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\">Secondary Stream (Lo-res) – used for motion detection, browsing archive etc (s<\/span><span class=\"f_BodyText\">ee &quot;<a href=\"dual_streaming.html\" class=\"topiclink\">Dual Stream Processing<\/a>&quot; for details).<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">Cameras may provide additional stream profiles (more than 2) but <\/span><span class=\"f_BodyText\">DW Spectrum uses only Primary and Secondary ones. <\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">In some cases, the profiles can be fetched and identified incorrectly. In this case it may be necessary to configure stream profiles manually.<\/span><\/p>\n\r<p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">To access those settings, u<\/span><span class=\"f_BodyTextIndent\">se the camera\'s context menu to open <\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Camera Settings<\/span><span class=\"f_BodyTextIndent\"> &gt; <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Expert &gt; Media Streaming<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Primary <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\">and <\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal; font-weight: bold;\">Secondary Stream Profiles<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> <\/span><span class=\"f_BodyTextIndent\">– specify the stream profiles for Primary and Secondary streams.<\/span><\/p><p class=\"p_BodyTextFirstIndent2\"><span class=\"f_BodyTextFirstIndent2\">The available profiles may vary depending on the vendor or model of the device used. <\/span><\/p>\n\r<p class=\"p_BodyTextFirstIndent2\"><span class=\"f_BodyTextIndent\">By default, DW Spectrum configures the optimal parameters for the stream profiles but it can be turned off and the settings setup on Camera can be used unchanged (see &quot;<a href=\"preventing_vms_from_c.html\" class=\"topiclink\">Preventing DW Spectrum from Changing Device Settings<\/a>&quot;).<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Use Media2 to fetch profiles<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> <\/span><span class=\"f_BodyTextIndent\">– in some case Media2 can work incorrectly. In this case it is possible to select the following options:<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextFirstIndent2\" style=\"font-weight: bold;\">Never<\/span><span class=\"f_BodyTextFirstIndent2\"> <\/span><span class=\"f_BodyTextIndent\">– always use Media to configure stream profiles<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Use if supported<\/span><span class=\"f_BodyTextIndent\"> – use Media2 if the device indicates its support<\/span><\/p><p class=\"p_BodyTextFirstIndent2\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 2.1250rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\" style=\"font-weight: bold;\">Auto<\/span><span class=\"f_T_Interface_Elements\" style=\"font-style: normal;\"> <\/span><span class=\"f_BodyTextIndent\">– use the built-in method to discover if the device supports Media2.<\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">See also:<\/span><\/p>\n\r<p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"disabling_recording_of_primary.html\" class=\"topiclink\">Disabling Recording of a Specific Stream<\/a><\/span><\/p><p class=\"p_BodyTextIndent\" style=\"text-indent: 0; padding-left: 0.8125rem; margin-left: 0.8750rem;\"><span class=\"f_BodyTextIndent\" style=\"font-family: Arial,\'Lucida Sans Unicode\',\'Lucida Grande\',\'Lucida Sans\';display:inline-block;width:0.8125rem;margin-left:-0.8125rem\">&#8226;<\/span><span class=\"f_BodyTextIndent\"><a href=\"disabling_secondary_stream.html\" class=\"topiclink\">Disabling a Secondary Stream<\/a><\/span><\/p><p class=\"p_BodyText\" style=\"page-break-inside: avoid;\"><span class=\"f_BodyText\">&nbsp;<\/span><\/p>\n\r"
})
